'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/** 以下所有接口公用的参数及返回
 * @param {String} authInfo - authInfo
 * @return {Object} Response
 */

var MtopApi = exports.MtopApi = [
/**
  * 获取设备列表
  * @param {String} appInfo 应用信息
  * @param {String} params 筛选条件
  * @param {String} deviceInfo 精灵设备信息
*/
'getAllDevices::mtop.alibaba.aicloud.iot.getAllDevices',

/**
  * 获取设备状态
  * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
  * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
*/
'getDeviceStatus::mtop.alibaba.aicloud.iot.getDeviceStatus',

/**
  * 控制设备状态
  * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
  * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
  * @param {Object} params 控制的详细入参
  * * @param {String} params.method 接口  'thing.attribute.set'
  * * @param {String} params.devId 设备Id标识（调用接口时 sdk 自动填写）
  * * @param {String} params.msgId （调用接口时 sdk 自动填写为 ''）
  * * @param {String} params.version 调用接口时 sdk 自动填写为 '1.0'）
  * * @param {Object} params.params 具体的控制属性与值 {key: val} ,WIFI 设备可传多个属性与值, Mesh设备只能传一个
*/
'deviceControl::mtop.alibaba.aicloud.iot.deviceControl',

/**
  * 获取物的模型
  * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
  * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
  * @param {String} productKey 产品Id sdk 自动填写）
*/
'getDeviceInfo::mtop.alibaba.aicloud.iot.getDeviceInfo',

/**
   * 获取面板配置接口
   * @param {String} params 参数
   * * @param {String} params.productKey 设备的productkey
   * * @param {String} params.devTypeCn 设备的devTypeCn
   * * @param {String} params.devTypeEn 设备的devTypeEn
   * * @param {String} params.devTerminalCn 设备的devTerminalCn
   * * @param {String} params.modelType 设备的modelType
   * * @param {String} params.terminalAbility 设备的terminalAbility
 */
'getPanelModelByPk::mtop.alibaba.aicloud.yiking.getPanelModelByPk',

/**
   * CC上获取物的模型
   * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
   * @param {String} productKey 产品Id sdk 自动填写）
 */
'getDeviceInfoForCC::mtop.alibaba.aicloud.iot.getDeviceInfoForCC',

/**
   * 获取设备详情
   * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
 */
'getDeviceDetail::mtop.alibaba.aicloud.iot.getDeviceDetail',

/**
   * 获取设备详情 FOR CC
   * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
 */
'getDeviceDetailForCC::mtop.alibaba.aicloud.iot.getDeviceDetailForCC',

/**
   * 获取设备详情 for alipay
   * @param {String} devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} skillId 设备技能标识（调用接口时 sdk 自动填写）
 */
'getDeviceDetailForAlipay::mtop.alibaba.aicloud.iot.getDeviceDetailForAlipay',

/**
   * 获取语料接口
   * @param {String} params {Object} 参数
   * @param {String} params.skillId 设备技能标识（调用接口时 sdk 自动填写）
   * @param {String} params.devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} params.productKey 产品Id sdk 自动填写）
 */
'getDeviceFunctionCorpus::mtop.alibaba.aicloud.iot.getDeviceFunctionCorpus',

/**
   * 获取语料接口For CC
   * @param {String} params {Object} 参数
   * @param {String} params.skillId 设备技能标识（调用接口时 sdk 自动填写）
   * @param {String} params.devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} params.productKey 产品Id sdk 自动填写）
 */
'getDeviceFunctionCorpusForCC::mtop.alibaba.aicloud.iot.getDeviceFunctionCorpusForCC',

/**
   * 获取语料接口For AliPay
   * @param {String} params {Object} 参数
   * @param {String} params.skillId 设备技能标识（调用接口时 sdk 自动填写）
   * @param {String} params.devId 设备Id标识（调用接口时 sdk 自动填写）
   * @param {String} params.productKey 产品Id sdk 自动填写）
 */
'getDeviceFunctionCorpusForAlipay::mtop.alibaba.aicloud.iot.getDeviceFunctionCorpusForAlipay',

/**
   * 获取产品信息
   * @param {String} productKey 产品Id sdk 自动填写）
 */
'getProductInfo::mtop.alibaba.aicloud.iotOpenPlatformApp.getProductConfig',

// 获取快捷控制场景列表 参数 userId 调用接口时会默认传入  无参数
'getFastControlSceneList::mtop.alibaba.aicloud.scene.getFastControlSceneList',

/* 执行快捷控制场景 
 * @params
 * sceneId String 场景的Id
 * type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
 */
'executeScene::mtop.alibaba.aicloud.scene.executeScene',

/* 获取场景列表
* @params
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* source String 请求入口 MY_HOME_PAGE 我家 FEEDS 首页feeds流
* extParams String(JSON)  '{}' 扩展参数
*/
'getSceneList::mtop.alibaba.aicloud.senceAPP.getSceneList', 'getSceneListType1::mtop.alibaba.aicloud.senceAPP.getSceneList', 'getSceneListType2::mtop.alibaba.aicloud.senceAPP.getSceneList', 'getSceneListType3::mtop.alibaba.aicloud.senceAPP.getSceneList',
/* 获取场景详情
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* source String 请求入口 MY_HOME_PAGE 我家 FEEDS 首页feeds流
*/
'getDetailScene::mtop.alibaba.aicloud.scene.getDetailScene',

/* 添加到我的场景
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* geofence String(JSON) '{}' 地理围栏信息
* iotDevice String(JSON) '{}' 设备信息
*/
'addMyScene::mtop.alibaba.aicloud.senceAPP.addMyScene',

/* 更新单条场景的可用状态
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* status String 状态 1可用 -1不可用
*/
'switchSceneStatus::mtop.alibaba.aicloud.scene.switchSceneStatus',

/** 
  * 创建或者更新一个场景
  * @params
  * detailScene String(JSON) '{}' 场景详情
*/
'createOrUpdateScene::mtop.alibaba.aicloud.scene.createOrUpdateScene',

/* 删除场景
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
*/
'deleteScene::mtop.alibaba.aicloud.scene.deleteScene',

/* 获取设备列表
* @params
* deviceClassification String 默认值 1  设备类型 1.trigger型设备 2.action型设备
*/
'getDeviceList::mtop.alibaba.aicloud.scene.getDeviceList',

/* 获取设备属性详情
* @params
* deviceClassification String 默认值 1  设备类型 1.trigger型设备 2.action型设备
* deviceId String 设备id
* typeGroup String 设备分组
* skillId String 技能id
* productKey String 型号
*/
'getDeviceModel::mtop.alibaba.aicloud.scene.getDeviceModel',

/* 更改场景顺序
* @params
* sceneIds String(Array) '[1, 2, 3]' 用户排序后的场景id列表
* source String 请求入口 MY_HOME_PAGE 我家 FEEDS 首页feeds流
*/
'orderSceneList::mtop.alibaba.aicloud.scene.orderSceneList',

/* 更改场景名称
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* sceneName String 场景名称
*/
'updateSceneName::mtop.alibaba.aicloud.scene.updateSceneName',

/* 更改场景icon
* @params
* sceneId String 场景的Id
* type Number 场景类型 1 官方推荐场景 2 用户离线推荐场景 3 可运行场
* icon String 场景图标
*/
'updateSceneIcon::mtop.alibaba.aicloud.scene.updateSceneIcon',

// 获取场景的icon列表 参数 userId 调用接口时会默认传入  无参数
'getSceneConfig::mtop.alibaba.aicloud.scene.getSceneConfig',

// 获取场景执行日志 参数 userId 调用接口时会默认传入  无参数
'getSceneLog::mtop.alibaba.aicloud.scene.getSceneLog',

// 清空场景执行日志 参数 userId 调用接口时会默认传入  无参数
'cleanSceneLog::mtop.alibaba.aicloud.scene.cleanSceneLog',

/* 创建地理围栏
* @params
* geofence String(JSON) '{}' 地理围栏信息
*/
'createGeofence::mtop.alibaba.aicloud.scene.createGeofence',

// 获取天猫精灵列表 参数 userId 调用接口时会默认传入  无参数
'getTmallGenineDeviceList::mtop.alibaba.aicloud.scene.getTmallGenineDeviceList',

/* 获取路由
* @params
* routerParams String(JSON) '{}' 
* extraParams String(JSON) '{}' 
*/
'getMultiPortRouter::mtop.alibaba.aicloud.t.router.getMultiPortRouterV3',

/* 获取路由 For alipay
 * @params
 * routerParams String(JSON) '{}' 
 * extraParams String(JSON) '{}' 
 */
'getMultiPortRouterForAlipay::mtop.alibaba.aicloud.routerForApp.getMultiPortRouterForAlipay',

/* 多element设备获取路由
 * @params
 * routerParams String(JSON) '{}' 
 * extraParams String(JSON) '{}' 
 * 参数示例
   { routerParams: JSON.stringify({"namespace":"tm_cc","category":"light","cdnEnv":"release","containers":[{"runtimeVersion":"1.0.0","runtime":"mini_app"}]}) }
 */
'getMultiPortYiKongRouter::mtop.alibaba.aicloud.elementRouter.getMultiPortYiKongRouter',

/* 批量获取品类物模型和面板物模型
 参数示例
 params: JSON.stringify({
     "devTerminalCn": "天猫精灵CC",
     "terminalAbility": 0,
     "modelType": 0,
     "params": [
       {
         $class: "com.alibaba.ai.iot.entity.platform.admin.param.PanelModelQueryParam",
         $: {
           "devTerminalCn": "天猫精灵CC",
           "terminalAbility": 0,
           "modelType": 0,
           "productKey": "238",
           "devTypeEn": "light",
           "devTypeCn": "灯"
         }
       },
       {
         $class: "com.alibaba.ai.iot.entity.platform.admin.param.PanelModelQueryParam",
         $: {
           "devTerminalCn": "天猫精灵CC",
           "terminalAbility": 0,
           "modelType": 0,
           "productKey": "110177",
           "devTypeEn": "outlet",
           "devTypeCn": "插座"
         }
       }
     ]
   })
*/
'batchGetModel::mtop.alibaba.aicloud.yiKong830.batchGetModel', 'getUserGroupDetail::mtop.alibaba.aicloud.t.iotGrouping.getUserGroupDetailV2', 'getUserGroupList::mtop.alibaba.aicloud.t.iotGrouping.getUserGroupList', 'groupControl::mtop.alibaba.aicloud.t.iotGrouping.groupControl',

/* 获取设备别名列表
  * @params
  * typeGroup String '插座' 
*/
'getDeviceAliasByDevCn::mtop.alibaba.aicloud.iot.getDeviceAliasByDevCnForCC',

/* 更新设备别名
  参数示例
  AliasParam: JSON.stringify({
    devId: 'a80171f9b30100b706007afa28010000',
    aliasType: 'custom',
    alias: '鱼死网破'
  })
*/
'updateDeviceAlias::mtop.alibaba.aicloud.showInfo.updateDeviceAliasForCCV2',

// 获取设备位置列表 参数无
'getDevLocationApp::mtop.alibaba.aicloud.iot.getDevLocationAppForCC',

/* 更新设备位置
  * @params
  * deviceId String '7Xipf2ddvDgDJMjJTEN8000000' 
  * zone String '客厅' 
*/
'setZone::mtop.alibaba.aicloud.iot.setZoneForCC',

/* 通过父设备的 devId 获取到所有子设备的信息
  * @params
  * parentDeviceId String '7Xipf2ddvDgDJMjJTEN8000000' 
  * extensions String(JSON) '{}' // 拓展参数 
*/
'getAllChildDevsByParentDevId::mtop.alibaba.aicloud.elementDevice.getAllChildDevsByParentDevId', 'getAllChildDevsByParentDevIdForCC::mtop.alibaba.aicloud.elementDevice.getAllDevsByParentDevIdForCC',

/* 云云设备根据设备获取语料及控制指令
  * @params
  * devId String
*/
'getCorpusAndControlParamByDev::mtop.alibaba.aicloud.YYdevice.getCorpusAndControlParamByDev', 'getCorpusAndControlParamByDevForCC::mtop.alibaba.aicloud.YYdevice.getCorpusAndControlParamByDevForCC',

// 获取最新的定时页面
'getStandardTimingUrl::mtop.alibaba.aicloud.iot.getStandardTimingUrl',

// 云食谱相关接口
'getRecomandRecipePage::mtop.alibaba.aicloud.recipe.getRecomandRecipePage', 'getFavoriteRecipeItem::mtop.alibaba.aicloud.recipe.getFavoriteRecipeItem', 'searchDetail::mtop.alibaba.aicloud.recipe.searchDetail', 'favoriteRecipeItem::mtop.alibaba.aicloud.recipe.favoriteRecipeItem', 'getRecipeProductDetailList::mtop.alibaba.aicloud.recipe.getRecipeProductDetailList', 'businessDeviceControl::mtop.alibaba.aicloud.recipe.businessDeviceControl', 'getDeviceCurrentStatus::mtop.alibaba.aicloud.recipe.getDeviceCurrentStatus', 'listDataRecipe::mtop.alibaba.aicloud.recipe.listDataRecipeV2', 'queryStepsByRecipeId::mtop.alibaba.aicloud.recipe.queryStepsByRecipeIdV2'];

// 获取 mtopApi
// getMtopApi () {
//   return [
//     'getDeviceStatus::mtop.alibaba.aicloud.iot.getDeviceStatus',
//     'deviceControl::mtop.alibaba.aicloud.iot.deviceControl',
//     'getStandardTimingUrl::mtop.alibaba.aicloud.iot.getStandardTimingUrl',
//     'getDeviceDetail::mtop.alibaba.aicloud.iot.getDeviceDetail',
//     'checkControlPk::mtop.alibaba.aicloud.iot.checkControlPk'
//   ]
// }