'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _API = require('./API');

var _nativeApi = require('./nativeApi');

var _nativeApi2 = _interopRequireDefault(_nativeApi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import { request } from '@ali/a8s';
// import '../depends/tg-iot-implements-api/lib/index.js'

var API = function () {
  function API() {
    (0, _classCallCheck3.default)(this, API);
  }

  (0, _createClass3.default)(API, [{
    key: 'distributeMtop',

    // mtop 接口分发
    value: function distributeMtop() {
      this.baseData = {};
      this.deviceStatusCallback = function () {};
      this.attributes = {};
      if (this.Params && this.Params.type === 'sence') {
        this.Params = {};
        this.normalApi(); // mtop接口分发
      } else {
        this.CCApi(); // CC 上这些 mtop 接口分发
        if (!this.Params.isTest) {
          this.getAllDevices = _nativeApi2.default.getAllDevices;
          this.getDeviceStatus = _nativeApi2.default.getDeviceStatus;
          this.getDeviceInfo = _nativeApi2.default.getProductTSL;
          this.container !== 'CC' && (this.deviceControl = _nativeApi2.default.controlDevice);
          this.getProductInfo = _nativeApi2.default.getProductInfo;

          if ((this.systemInfo.app === 'TGenie' || this.systemInfo.app === 'alipay') && this.container !== 'CC') {
            // 支付宝小程序上用这个
            this.getDeviceFunctionCorpus = this.getDeviceFunctionCorpusForAlipay;
            this.getMultiPortRouter = this.getMultiPortRouterForAlipay;
            this.getDeviceDetail = this.getDeviceDetailForAlipay;
          } else {
            // cc上用这个
            this.getDeviceFunctionCorpus = this.getDeviceFunctionCorpusForCC;
            this.getAllChildDevsByParentDevId = this.getAllChildDevsByParentDevIdForCC;
            this.getDeviceDetail = this.getDeviceDetailForCC;
            this.getCorpusAndControlParamByDev = this.getCorpusAndControlParamByDevForCC;
          }
        }
      }
    }

    // 设置参数

  }, {
    key: 'setParams',
    value: function setParams(_ref) {
      var devId = _ref.devId,
          productKey = _ref.productKey,
          _ref$skillId = _ref.skillId,
          skillId = _ref$skillId === undefined ? 3404 : _ref$skillId,
          _ref$deviceName = _ref.deviceName,
          deviceName = _ref$deviceName === undefined ? '' : _ref$deviceName;

      this.Params = this.Params || { deviceInfo: {} };
      this.Params.deviceInfo = this.Params.deviceInfo || {};

      this.Params.deviceInfo.devId = devId || this.Params.deviceInfo.devId;
      this.Params.deviceInfo.productKey = productKey || this.Params.deviceInfo.productKey;
      this.Params.deviceInfo.skillId = skillId || this.Params.deviceInfo.skillId;
      this.Params.deviceInfo.deviceName = deviceName || this.Params.deviceInfo.deviceName;
    }
  }, {
    key: 'CCApi',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var _this = this;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _API.MtopApi.forEach(function (item) {
                  var _item$split = item.split('::'),
                      _item$split2 = (0, _slicedToArray3.default)(_item$split, 2),
                      method = _item$split2[0],
                      apiName = _item$split2[1];

                  _this[method] = function () {
                    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


                    // 注入默认参数 和 传入参数
                    var defaultParams = _this.mtopDistributeParams(method);
                    var opt = {
                      apiName: apiName,
                      data: (0, _assign2.default)({}, defaultParams, params)
                    };
                    return new _promise2.default(function (resolve, reject) {
                      var checkResult = _this.mtopCheckParms(method, (0, _assign2.default)({}, defaultParams, params));
                      if (checkResult.error) {
                        return reject(method + '\u63A5\u53E3\uFF1A' + checkResult.error);
                      }

                      if (_this.systemInfo.app === 'GenieWebApps' || _this.container === 'CC') {
                        // CC 上调用
                        var reqParams = {
                          ignore_aliauth_autologin: "YES",
                          apiName: opt.apiName,
                          apiVersion: '1.0',
                          needEcodeSign: true,
                          useGenieEnv: true,
                          data: opt.data
                        };
                        my.call('mtop', reqParams, function (res) {
                          res.data = res.data || {};
                          res.ret = res.ret || [];
                          if (res.retType === 0 || res['ret'][0] === 'SUCCESS::调用成功' || res.data.statusCode === '200' || res.data.success === 'true') {
                            resolve(res.data);
                          } else {
                            res.errorMessage = res.msgInfo;
                            res.errorCode = res.msgCode;
                            reject(res);
                          }
                        }, function (err) {
                          err.errorMessage = err.msgInfo;
                          err.errorCode = err.msgCode;
                          reject(err);
                        });
                      } else {
                        my.aiot.sendMtop({
                          api: opt.apiName,
                          data: opt.data,
                          needLogin: true,
                          success: function success(res) {
                            resolve({
                              model: res
                            });
                          },
                          fail: function fail(err) {
                            _this.console && console.log('调用接口失败了：', (0, _stringify2.default)(err));
                            err.errorMessage = err.msgInfo;
                            err.errorCode = err.msgCode;
                            reject(err);
                          }
                        });
                      }
                    });
                  };
                });

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function CCApi() {
        return _ref2.apply(this, arguments);
      }

      return CCApi;
    }()

    // 获取基础信息

  }, {
    key: 'getbaseInfo',
    value: function getbaseInfo() {
      var _this2 = this;

      var deviceName = this.Params.deviceInfo && this.Params.deviceInfo.deviceName;
      return new _promise2.default(function (resolve, reject) {
        _this2.baseData = {};
        if (deviceName) {
          _this2.baseData.deviceDetail = {
            deviceName: deviceName
          };
        }

        // 10秒中超时
        _this2.baseInfoTimeout = setTimeout(function () {
          resolve({ error: '接口调用超时' });
        }, 20000);

        !deviceName && _this2.getDeviceDetail().then(function (deviceDetail) {
          _this2.console && console.log('获取设备详情返回时间点：', (0, _stringify2.default)(deviceDetail), (0, _stringify2.default)(new Date()));
          if (!deviceDetail.model.devId) {
            resolve({ msgInfo: '你没有该设备' });
            return;
          }
          if ((0, _stringify2.default)(deviceDetail.model) !== '{}') {
            deviceDetail.model.deviceName = deviceDetail.model.alias || deviceDetail.model.devName || deviceDetail.model.devType;
            _this2.baseData.deviceDetail = deviceDetail.model;
            // 保存埋点数据
            _this2.saveSpmInfo(deviceDetail.model, function (user_role) {
              console.error('user_role', user_role);
              if (_this2.baseData.deviceInfo && _this2.baseData.productInfo) resolve(_this2.baseData);
            });

            if (deviceDetail.model.platform.name === 'SIGMESH' && !deviceDetail.model.shareInfo.isShareDevice) {
              // 本地控制逻辑
              console.error('本地控制逻辑>>>>');
              _this2.localControl(deviceDetail.model);
            }

            // 获取物的模型
            _this2.getDeviceInfo().then(function (deviceInfo) {
              deviceInfo.model = deviceInfo.model || {};
              _this2.console && console.log('获取物的模型返回时间点：', (0, _stringify2.default)(deviceInfo), (0, _stringify2.default)(new Date()));
              if ((0, _stringify2.default)(deviceInfo.model.tsl) !== '{}') {
                _this2.baseData.deviceInfo = deviceInfo.model;
                if (_this2.baseData.productInfo && _this2.baseData.deviceDetail) resolve(_this2.baseData);
              } else {
                resolve({ msgInfo: '未获取到该设备的物模型信息' });
              }
            }).catch(function (err) {
              _this2.console && console.log('获取物模型失败：', (0, _stringify2.default)(err));
              resolve({ msgInfo: '获取物模型失败：' + (err.msg || err.msgInfo) });
            });

            // 获取设备信息
            _this2.getProductInfo().then(function (productInfo) {
              _this2.console && console.log('获取产品信息返回时间点：', (0, _stringify2.default)(productInfo), (0, _stringify2.default)(new Date()));
              if ((0, _stringify2.default)(productInfo.model) !== '{}') {
                _this2.baseData.productInfo = productInfo.model;
                if (_this2.baseData.deviceInfo && _this2.baseData.deviceDetail) resolve(_this2.baseData);
              } else {
                resolve({
                  msgInfo: '未获取到该设备的产品信息'
                });
              }
            }).catch(function (err) {
              _this2.console && console.log('获取产品信息失败：', (0, _stringify2.default)(err));
              resolve({ msgInfo: '获取产品信息失败：' + (err.msg || err.msgInfo) });
            });
          } else {
            resolve({ msgInfo: '未获取到设备详情信息' });
          }
        }).catch(function (err) {
          _this2.console && console.log('获取设备详情失败：', (0, _stringify2.default)(err));
          resolve({ msgInfo: '获取设备详情失败：' + (err.msg || err.msgInfo) });
        });
      });
    }

    // 保存埋点数据

  }, {
    key: 'saveSpmInfo',
    value: function saveSpmInfo() {
      var deviceDetail = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

      // 埋点
      var devId = deviceDetail.devId,
          productKey = deviceDetail.productKey,
          devTypeEn = deviceDetail.devTypeEn,
          _deviceDetail$platfor = deviceDetail.platform,
          platform = _deviceDetail$platfor === undefined ? {} : _deviceDetail$platfor,
          skillId = deviceDetail.skillId,
          sourceType = deviceDetail.sourceType,
          userId = deviceDetail.userId,
          _deviceDetail$shareIn = deviceDetail.shareInfo,
          shareInfo = _deviceDetail$shareIn === undefined ? {} : _deviceDetail$shareIn,
          _deviceDetail$screenN = deviceDetail.screenName,
          screenName = _deviceDetail$screenN === undefined ? '' : _deviceDetail$screenN;


      var user_role = 'owner';
      if (sourceType === 'family') {
        user_role = 'member';
      } else if (shareInfo.isShareDevice) {
        user_role = 'sharer';
      }

      var _my$getSystemInfoSync = my.getSystemInfoSync(),
          app = _my$getSystemInfoSync.app,
          model = _my$getSystemInfoSync.model;

      var container_type = '';
      if (app === 'UNKNOWN' && model === 'AliOSThings') {
        container_type = 'box_CC_MINI';
      } else if (app === 'genie' || app === 'GenieWebApps' || this.container === 'CC') {
        container_type = 'box_CC';
      } else if (app === 'TGenie') {
        container_type = 'app';
      } else {
        container_type = 'alipay';
      }

      this.spmParamsData = {
        spmA: this.spmA,
        spmB: this.spmB,
        container_type: container_type,
        platform_type: 'IoT',
        iot_type: platform.name,
        dev_type_en: devTypeEn,
        dev_id: devId,
        skill_id: skillId,
        user_id: userId,
        product_key: productKey,
        is_share: shareInfo.isShareDevice,
        user_role: user_role, // owner,member,sharer
        panel_type: screenName || this.Params.screenName || '宜控'
      };
      callback(user_role);
    }

    // mtop接口分发

  }, {
    key: 'normalApi',
    value: function normalApi() {
      var _this3 = this;

      _API.MtopApi.forEach(function (item) {
        var _item$split3 = item.split('::'),
            _item$split4 = (0, _slicedToArray3.default)(_item$split3, 2),
            method = _item$split4[0],
            apiName = _item$split4[1];

        _this3[method] = function () {
          var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


          // 注入默认参数 和 传入参数
          var defaultParams = _this3.mtopDistributeParams(method);
          var opt = {
            apiName: apiName,
            data: (0, _assign2.default)({}, defaultParams, params)
          };
          return new _promise2.default(function (resolve, reject) {
            var checkResult = _this3.mtopCheckParms(method, (0, _assign2.default)({}, defaultParams, params));
            if (checkResult.error) {
              return reject(method + '\u63A5\u53E3\uFF1A' + checkResult.error);
            }
            _this3.Mtop(opt).then(function (resp) {
              resolve(resp);
            }, function (error) {
              reject(error);
            });
          });
        };
      });
    }

    // 注入默认参数 和 传入参数

  }, {
    key: 'mtopDistributeParams',
    value: function mtopDistributeParams(method) {
      var _ref3 = this.Params.deviceInfo || {},
          devId = _ref3.devId,
          productKey = _ref3.productKey,
          skillId = _ref3.skillId;

      switch (method) {
        case 'getDeviceStatus':
          return { devId: devId, skillId: skillId };
        case 'deviceControl':
          return { devId: devId, skillId: skillId };
        case 'getDeviceInfo':
          return { devId: devId, skillId: skillId, productKey: productKey };
        case 'getDeviceDetail':
          return { devId: devId, skillId: skillId };
        case 'getDeviceDetailForCC':
          return { devId: devId, skillId: skillId };
        case 'getDeviceDetailForAlipay':
          return { devId: devId, skillId: skillId };
        case 'getCorpusAndControlParamByDev':
          return { devId: devId };
        case 'getCorpusAndControlParamByDevForCC':
          return { devId: devId };
        case 'getProductInfo':
          return { productKey: productKey };
        case 'getDeviceFunctionCorpus':
          return { params: (0, _stringify2.default)({ devId: devId, skillId: skillId, productKey: productKey }) };
        case 'getDeviceFunctionCorpusForCC':
          return { params: (0, _stringify2.default)({ devId: devId, skillId: skillId, productKey: productKey }) };
        case 'getDeviceFunctionCorpusForAlipay':
          return { params: (0, _stringify2.default)({ devId: devId, skillId: skillId, productKey: productKey }) };
        case 'getAllDevices':
          return { appInfo: (0, _stringify2.default)({
              "osVersion": "13.5.1",
              "appName": "天猫精灵",
              "deviceModel": "iPhone12,   8",
              "appVersion": "4.6.0.7",
              "platform": "iOS"
            }), params: (0, _stringify2.default)({ "terminalName": "天猫精灵手机", "modelType": 0 })
          };
        default:
          return {};
      }
    }

    /**
     * motp 接口必传参数校验
     * @param {*} type 参数类型
     */

  }, {
    key: 'mtopCheckParms',
    value: function mtopCheckParms(method, params) {
      var mustParams = {};
      switch (method) {
        case 'getDeviceDetail':
          mustParams = { devId: 'string', skillId: 'string' };
          break;
      }

      for (var i in mustParams) {
        if (!params[i]) {
          return { error: '\u7F3A\u5C11\u5FC5\u586B\u53C2\u6570' + i };
        }
      }
      return { success: 200 };
    }
    // 是否可以控制

  }, {
    key: 'couldIControl',
    value: function couldIControl() {
      if (!this.meshDeviceStatus) return {};
      if (this.meshDeviceStatus.hasOnlineVoiceBox) return {};
      var msgInfo = '';
      console.log(this.meshDeviceStatus.AndroidLocationStatus, 'this.meshDeviceStatus.AndroidLocationStatus>>>>');
      if (!this.meshDeviceStatus.phoneMeshStatus) {
        msgInfo = '您的蓝牙开关还没打开哦';
        // } else if (!this.meshDeviceStatus.AndroidLocationStatus && this.isAndriod()) {
        //   msgInfo = '该设备需要打开定位权限才能控制哦'
      }
      return {
        msgInfo: msgInfo
      };
    }

    // 本地控制逻辑

  }, {
    key: 'localControl',
    value: function localControl(device) {
      var _this4 = this;

      var _ref4 = this.Params.deviceInfo || {},
          devId = _ref4.devId,
          productKey = _ref4.productKey,
          skillId = _ref4.skillId;

      // 默认的蓝牙状态


      this.meshDeviceStatus = {
        isMeshDevice: device.platform.name, // 是否是蓝牙设备
        meshConnestStatus: null, // 蓝牙连接设备的状态
        phoneMeshStatus: null, // 手机打开蓝牙的状态
        hasOnlineVoiceBox: null, // 是否有音箱在线的状态
        // meshConnecting: null, // 蓝牙正在连接中...
        AndroidLocationStatus: null, // 蓝牙定位开启状态
        AndroidLocationPermissionStatus: null // 蓝牙定位权限状态


        // 开始连接蓝牙
      };this.startLocalConnect();

      my.aiot.getDeviceConnectStatus({
        deviceId: devId,
        productKey: productKey,
        skillId: Number(skillId),
        success: function success(res) {
          _this4.meshDeviceStatus.meshConnestStatus = res.connectByPhone; // 蓝牙连接设备的状态
          _this4.meshDeviceStatus.hasOnlineVoiceBox = res.connectBySundbox; // 是否有音箱在线的状态
          _this4.meshDeviceStatus.phoneMeshStatus = res.ext.bleEnable; // 更新蓝牙打开状态
          _this4.meshDeviceStatus.AndroidLocationStatus = res.ext.locationEnable; // 更新全局定位连接设备的状态

          console.error('设备连接log>>>>', res);
        },
        fail: function fail(err) {
          console.error('设备连接log失败>>>>', err);
        }
      });

      // 兼听音箱状态
      my.aiot.onGenieBoxStatusChange(function (event) {
        console.log('事件监听-音箱在线状态>>>>', event);
        _this4.meshDeviceStatus.hasOnlineVoiceBox = event.isOnline;
      });

      // 兼听设备状态
      my.aiot.onConnectStatusChange(function (event) {
        console.error('事件监听-设备在线状>>>>', event);
        var status = event.connectStatus === 0 || event.status === 0;
        if (event.connectStatus === 0 || event.status === 0) {
          status = true;
          _this4.meshDeviceStatus.phoneMeshStatus = true; // 更新蓝牙打开状态
        } else {
          status = false;
          // this.shouldConnecting = true
        }
        if (event.status === 2) {
          // this.meshDeviceStatus.phoneMeshStatus = false // 更新蓝牙打开状态
          // 开始连接蓝牙
          _this4.startLocalConnect();
        } else {
          _this4.meshDeviceStatus.phoneMeshStatus = true; // 更新蓝牙打开状态
        }
        _this4.meshDeviceStatus.meshConnestStatus = status; // 蓝牙连接设备的状态
      });
    }
    // 开始连接蓝牙

  }, {
    key: 'startLocalConnect',
    value: function startLocalConnect() {
      var _this5 = this;

      var _ref5 = this.Params.deviceInfo || {},
          devId = _ref5.devId,
          productKey = _ref5.productKey,
          skillId = _ref5.skillId;

      console.log('连接蓝牙>>>>');
      // 开始连接
      my.aiot.startLocalConnect({
        deviceId: devId,
        productKey: productKey,
        skillId: Number(skillId),
        success: function success(res) {
          _this5.meshDeviceStatus.meshConnestStatus = res.connectStatus === 0; // 蓝牙连接设备的状态
          console.error('startLocalConnect成功>>>>', res);
        },
        fail: function fail(err) {
          console.error('startLocalConnect失败>>>>', err);
        }
      });
    }

    // 获取设备状态 并 兼听

  }, {
    key: 'getDeviceStatusAndListening',
    value: function getDeviceStatusAndListening(_ref6, status) {
      var _this6 = this;

      var _ref6$callback = _ref6.callback,
          callback = _ref6$callback === undefined ? function () {} : _ref6$callback,
          _ref6$isList = _ref6.isList,
          isList = _ref6$isList === undefined ? false : _ref6$isList;

      var _ref7 = this.Params.deviceInfo || {},
          devId = _ref7.devId,
          productKey = _ref7.productKey,
          skillId = _ref7.skillId;

      this.waitReceiveDeviceStatus = false;
      setTimeout(function () {
        _this6.deviceStatusCallback = callback; // 设备属性返回

        // 小程序IDE上，轮询方法、持续获取设备状态
        console.log('第一次获取数据 devId', devId, isList);
        if (!isList && devId) {
          _this6.keepGetDeviceStatus();
        }

        // 轮询设备状态
        // this.pollingOpen = true
        // this.pollingDeviceStatus()

        if (!_this6.Params.isTest) {
          // 长链接接口数据
          console.log('打开长链接兼容new');
          my.aiot.offSyncDeviceInfo(_this6.listenDeviceInfo);
          _this6.listenDeviceInfo = function (data) {
            console.log(status, '收到的长链接数据', (0, _stringify2.default)(data));
            if (!data) return console.log('长链接收到data为空');
            for (var i = 0; i < data.length; i++) {
              if (status === 'allListen') {
                _this6.attributes = (0, _assign2.default)(_this6.attributes, data[i].attr); // 保留当前最新的属性状态
                _this6.deviceStatusCallback({
                  type: 'syncAllDeviceResult',
                  devId: data[i].deviceId,
                  attr: data[i].attr
                });
              } else if (data[i].deviceId === devId) {
                if (_this6.waitReceiveDeviceStatus) return console.log('拦截长链接的数据'); // 控制的3秒内，不接收消息，3秒后，主动获取
                _this6.attributes = (0, _assign2.default)(_this6.attributes, data[i].attr); // 保留当前最新的属性状态
                _this6.deviceStatusCallback({
                  type: 'syncDeviceInfoResult',
                  devId: data[i].deviceId,
                  attr: data[i].attr
                });
              }
            }
            // [{"deviceId":"a80171ee000000667d6b07da78000000","attr":{"powerstate":0}}]
          };
          my.aiot.onSyncDeviceInfo(_this6.listenDeviceInfo);
        } else {
          // 轮询设备状态
          _this6.pollingDeviceStatus();
        }
      }, 200);
    }

    // 小程序IDE上，轮询方法、持续获取设备状态

  }, {
    key: 'keepGetDeviceStatus',
    value: function keepGetDeviceStatus() {
      var _this7 = this;

      var _ref8 = this.Params.deviceInfo || {},
          productKey = _ref8.productKey;

      if (!productKey) return console.log('keepGetDeviceStatus 无PK不从重新轮询'); // 无PK不从重新轮询
      // 主动获取设备状态
      console.log('获取设备状态中...');
      this.getDeviceStatus().then(function (resp) {
        if (_this7.waitReceiveDeviceStatus) return console.log('拦截数据'); // 控制的3秒内，不接收消息，3秒后，主动获取
        if (resp.model && resp.model.attr) {
          _this7.deviceData = resp.model.attr;
          _this7.attributes = (0, _assign2.default)(_this7.attributes, resp.model.attr); // 保留当前最新的属性状态
          _this7.deviceStatusCallback({
            type: 'APIResult',
            attr: resp.model.attr
          });
        } else {
          _this7.stopPolling();
          _this7.deviceStatusCallback({
            type: 'errorResult',
            errorInfo: resp,
            attr: {}
          });
        }
      }).catch(function (err) {
        console.log('获取设备状态失败', err);
        _this7.stopPolling();
        _this7.deviceStatusCallback({
          type: 'errorResult',
          errorInfo: err,
          attr: {}
        });
      });
    }

    // 控制设备状态属性

  }, {
    key: 'setDeviceStatus',
    value: function setDeviceStatus(_ref9) {
      var attr = _ref9.attr,
          method = _ref9.method,
          spm = _ref9.spm;

      var _this8 = this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var groupControl = arguments[2];

      var _ref10 = this.Params.deviceInfo || {},
          devId = _ref10.devId,
          skillId = _ref10.skillId;

      var option = {
        params: attr
        // params.method ||
      };option.method = method || 'thing.attribute.set';
      option.devId = params.devId || devId;
      option.msgId = '';
      option.version = '1.0';

      return new _promise2.default(function (resolve, reject) {
        var waitControlTime = 3000;

        // 判断是否无法控制
        var controlInfo = _this8.couldIControl();
        console.log('controlInfo>>>>', controlInfo);
        if (controlInfo.msgInfo) {
          _this8.deviceStatusCallback({
            type: 'warning',
            errorInfo: controlInfo.msgInfo,
            attr: _this8.attributes
          });
          reject({ msgInfo: controlInfo.msgInfo });
          return;
        }

        // 操作过快提示
        console.error('***', _this8.alreadyControl);
        if (_this8.alreadyControl) {
          // console.log(JSON.stringify(this.attributes), '&&&')
          // this.respCallback({ model: { attr: this.attributes } })
          _this8.deviceStatusCallback({
            type: 'warning',
            errorInfo: '请不要操作过快哦',
            attr: _this8.attributes
          });
          reject({ msgInfo: '请不要操作过快哦' });
          return;
        }
        _this8.alreadyControl = true;
        _this8.SET_TIMEOUT && clearTimeout(_this8.SET_TIMEOUT);
        _this8.SET_TIMEOUT = setTimeout(function () {
          _this8.alreadyControl = false;
        }, 1000);

        // waitControlTime 时间内种内
        _this8.waitReceiveDeviceStatus = true;
        // 停止轮询
        _this8.stopPolling();
        clearTimeout(_this8.controlTimeOut);

        // 立刻修改面板状态
        _this8.attributes = (0, _assign2.default)(_this8.attributes, (0, _extends3.default)({}, option.params));
        console.error('点击存的属性>>>>', _this8.attributes);
        _this8.deviceStatusCallback({
          type: 'setResult',
          // attr: {...this.deviceData, ...option.params},
          attr: (0, _extends3.default)({}, option.params),
          params: params
        });

        // 设置设备属性
        console.log('params.devId || devId', params.devId || devId, spm);
        // 控制埋点
        if (spm !== 'fastControl') {
          _this8.setBaseSpm('控制属性点击', _this8.spmA + '.' + _this8.spmB + '.' + _this8.getControlStatus(attr), 'controlClickEvent', 'control', { control_property: _this8.getControlStatus(attr), control_path: 'cloud' }); // spm数据处理
          _this8.setPageSpmControlTimes(); // 控制次数埋点
        } else {
          _this8.setPageSpmErlangFastControl(); // 快捷控制次数埋点
        }
        _this8.deviceControl({
          params: (0, _stringify2.default)(option),
          devId: params.devId || devId,
          skillId: params.skillId || skillId
        }).then(function (resp) {
          // 控制轮询
          _this8.controlTimeOut = setTimeout(function () {
            _this8.waitReceiveDeviceStatus = false;

            // 抓取设备状态
            _this8.keepGetDeviceStatus();

            // 继续轮询
            _this8.pollingOpen && _this8.pollingDeviceStatus();
          }, waitControlTime);

          if (resp.model && resp.model !== 'null') {
            _this8.setBaseSpm('控制发送成功', _this8.spmA + '.' + _this8.spmB + '.' + _this8.getControlStatus(attr), 'exposureEvent', 'control_send', { control_property: _this8.getControlStatus(attr), control_path: 'cloud' }); // spm数据处理
            resolve(resp);
          } else {
            if (spm !== 'fastControl') {
              _this8.setBaseSpm('控制执行失败', _this8.spmA + '.' + _this8.spmB + '.' + _this8.getControlStatus(attr), 'exposureEvent', 'control_run_fail', { control_property: _this8.getControlStatus(attr), control_path: 'cloud' }); // spm数据处理
              _this8.setPageSpmControlFailTimes(); // 操作失败次数埋点
            } else {
              _this8.setPageSpmErlangFastControlFail(); // 快捷操作失败次数埋点
            }
            var msgInfo = '操作失败';
            // 音箱不在线,无法推送指令
            if (err.msg === '音箱不在线,无法推送指令' || err.message === '音箱不在线,无法推送指令' || err.msgInfo === '音箱不在线,无法推送指令' || err.kBoneJSBridgeErrorMessage === '音箱不在线,无法推送指令' || err.localizedMsg === '音箱不在线,无法推送指令') {
              msgInfo = '音箱不在线,无法推送指令';
            } else if (err.msg === '请不要操作过快哦' || err.message === '请不要操作过快哦' || err.msgInfo === '请不要操作过快哦' || err.kBoneJSBridgeErrorMessage === '请不要操作过快哦' || err.localizedMsg === '请不要操作过快哦') {
              msgInfo = '请不要操作过快哦';
            } else if (err.msg === '定位权限没有开启' || err.message === '定位权限没有开启' || err.msgInfo === '定位权限没有开启' || err.kBoneJSBridgeErrorMessage === '定位权限没有开启' || err.localizedMsg === '定位权限没有开启') {
              msgInfo = '定位权限没有开启';
            } else if (err.msg === '手机设置中的天猫精灵应用定位权限未开启' || err.message === '手机设置中的天猫精灵应用定位权限未开启' || err.msgInfo === '手机设置中的天猫精灵应用定位权限未开启' || err.kBoneJSBridgeErrorMessage === '手机设置中的天猫精灵应用定位权限未开启' || err.localizedMsg === '手机设置中的天猫精灵应用定位权限未开启') {
              msgInfo = '手机设置中的天猫精灵应用定位权限未开启';
            }
            // 
            _this8.deviceStatusCallback({
              type: 'warning',
              errorInfo: msgInfo,
              attr: _this8.attributes
            });
            reject({ msgInfo: msgInfo });
          }
          // resolve(resp)
        }).catch(function (err) {
          if (err.msgInfo === 'Operation queue has unfinished tasks') {
            return;
          }
          // 控制重新主动获取数据
          _this8.controlTimeOut = setTimeout(function () {
            _this8.waitReceiveDeviceStatus = false;

            // 抓取设备状态
            _this8.keepGetDeviceStatus();

            // 继续轮询
            _this8.pollingOpen && _this8.pollingDeviceStatus();
          }, waitControlTime);

          var msgInfo = '操作失败';
          // 音箱不在线,无法推送指令
          if (err.msg === '音箱不在线,无法推送指令' || err.message === '音箱不在线,无法推送指令' || err.msgInfo === '音箱不在线,无法推送指令' || err.kBoneJSBridgeErrorMessage === '音箱不在线,无法推送指令' || err.localizedMsg === '音箱不在线,无法推送指令') {
            msgInfo = '音箱不在线,无法推送指令';
          } else if (err.msg === '请不要操作过快哦' || err.message === '请不要操作过快哦' || err.msgInfo === '请不要操作过快哦' || err.kBoneJSBridgeErrorMessage === '请不要操作过快哦' || err.localizedMsg === '请不要操作过快哦') {
            msgInfo = '请不要操作过快哦';
          } else if (err.msg === '定位权限没有开启' || err.message === '定位权限没有开启' || err.msgInfo === '定位权限没有开启' || err.kBoneJSBridgeErrorMessage === '定位权限没有开启' || err.localizedMsg === '定位权限没有开启') {
            msgInfo = '定位权限没有开启';
          } else if (err.msg === '手机设置中的天猫精灵应用定位权限未开启' || err.message === '手机设置中的天猫精灵应用定位权限未开启' || err.msgInfo === '手机设置中的天猫精灵应用定位权限未开启' || err.kBoneJSBridgeErrorMessage === '手机设置中的天猫精灵应用定位权限未开启' || err.localizedMsg === '手机设置中的天猫精灵应用定位权限未开启') {
            msgInfo = '手机设置中的天猫精灵应用定位权限未开启';
          }
          // 前往设备详情页面
          err.msgInfo = msgInfo;
          if (spm !== 'fastControl') {
            _this8.setBaseSpm('控制执行失败', _this8.spmA + '.' + _this8.spmB + '.' + _this8.getControlStatus(attr), 'exposureEvent', 'control_run_fail', { control_property: _this8.getControlStatus(attr), control_path: 'cloud' }); // spm数据处理
            _this8.setPageSpmControlFailTimes(); // 操作失败次数埋点
          } else {
            _this8.setPageSpmErlangFastControlFail(); // 快捷操作失败次数埋点
          }
          reject(err);
        });
      });
    }
    // 获取控制属性

  }, {
    key: 'getControlStatus',
    value: function getControlStatus(attr) {
      var str = '';
      for (var i in attr) {
        str += i + '_';
      }
      return str.slice(0, str.length - 1);
    }

    // 轮询获取设备状态

  }, {
    key: 'pollingDeviceStatus',
    value: function pollingDeviceStatus() {
      var _this9 = this;

      var _ref11 = this.Params.deviceInfo || {},
          productKey = _ref11.productKey;

      if (!productKey) return console.log('pollingDeviceStatus 无PK不从重新轮询'); // 无PK不从重新轮询
      clearTimeout(this.polling);
      this.polling = setTimeout(function () {
        // 持续获取设备状态
        _this9.keepGetDeviceStatus();

        // 继续轮询
        _this9.pollingDeviceStatus();
      }, 3000);
    }

    // 停止轮询

  }, {
    key: 'stopPolling',
    value: function stopPolling() {
      clearTimeout(this.polling);
    }
    // 前往设备详情页面

  }, {
    key: 'goDeviceDetail',
    value: function goDeviceDetail() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

      if (this.systemInfo.app === 'TGenie') {
        var _ref12 = this.Params.deviceInfo || {},
            devId = _ref12.devId,
            skillId = _ref12.skillId;

        var url = 'https://market.m.taobao.com/app/genie/weex/pages/device-manager?wh_weex=true&from=control&_ali_nav_title_=\u8BBE\u5907\u8BE6\u60C5&devId=' + devId + '&skillId=' + skillId;
        my.call('algservices', {
          api: 'common.pageRouter.openUrl',
          params: {
            url: url
          }
        }, function (result) {
          console.info('openUrl ===>', (0, _stringify2.default)(result));
        });
      } else {
        callback();
      }
    }
  }]);
  return API;
}();

exports.default = API;