'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _resultCode = require('./resultCode.js');

var _resultCode2 = _interopRequireDefault(_resultCode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JsBridge = function () {
  function JsBridge() {
    (0, _classCallCheck3.default)(this, JsBridge);
  }

  (0, _createClass3.default)(JsBridge, [{
    key: 'jsBridge',

    // 调用 jsBridge
    value: function jsBridge(api) {
      var _this = this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var jsBridgeApi = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'algservices';

      if (!api) return console.error('api不能不传');
      return new _promise2.default(function (resolve, reject) {
        my.call(jsBridgeApi, {
          api: api,
          params: params
        }, function (resp) {
          // 未填必填参数 - 报错返回
          if (resp.error && resp.errorMessage) {
            if (_this.isIos()) {
              try {
                reject(JSON.parse(resp.errorMessage || '{}'));
              } catch (error) {
                reject({ errorCode: 'FAIL', errorMessage: api + '接口调用失败' });
              }
            } else {
              reject({ errorCode: resp.errorCode || 'FAIL', errorMessage: resp.errorMessage });
            }
          }

          // 参数错后 - 报错返回
          if (resp.result && resp.result.errorCode) {
            reject(resp.result);
          }

          if (resp.error) reject(resp);

          resolve(resp.result);
        }, function (error) {
          reject(error);
        });
      });
    }

    // Mtop 接口

  }, {
    key: 'Mtop',
    value: function Mtop() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          apiName = _ref.apiName,
          _ref$data = _ref.data,
          data = _ref$data === undefined ? {} : _ref$data,
          _ref$extensions = _ref.extensions,
          extensions = _ref$extensions === undefined ? {} : _ref$extensions;

      return new _promise2.default(function (reslove, reject) {
        if (!apiName) return reject({ error: 'apiName不能不传' });
        var apiData = (0, _extends3.default)({
          apiName: apiName,
          useGenieEnv: true,
          apiVersion: '1.0',
          data: data
        }, extensions);
        if (apiName === 'mtop.alibaba.aicloud.scene.createOrUpdateScene') {
          apiData.method = 'POST';
        }
        _this2.jsBridge('common.network.alilabsMtop', apiData).then(function (resp) {
          resp.success += '';
          resp.result && (resp.result.success += '');
          if (resp.error || resp.success !== 'true' && (!resp.result || resp.result.success !== 'true')) {
            if (resp.result && resp.result.msgInfo) {
              resp.result.errorMessage = resp.result.msgInfo;
              resp.result.errorCode = resp.result.msgCode;
              reject(resp.result);
            } else if (resp.msgInfo) {
              resp.errorMessage = resp.msgInfo;
              resp.errorCode = resp.msgCode;
              reject(resp);
            } else {
              reject(resp);
            }
          }
          resp = resp.result || resp;
          try {
            if (resp.model !== undefined) {
              if (resp.model.retValue) {
                resp.result = resp.model.retValue;
                delete resp.model;
              } else {
                resp.result = resp.model;
                delete resp.model;
              }
            }
          } catch (error) {}
          reslove(resp);
        }).catch(function (error) {
          if (error.result && error.result.msgInfo) {
            error.result.errorMessage = error.result.msgInfo;
            error.result.errorCode = error.result.msgCode;
            reject(error.result);
          } else {
            reject(error);
          }
        });
      });
    }

    /**
     *  接口返回信息检查
     * @param {*} method 方法名
     * @param {*} data 数据
     */

  }, {
    key: 'resultCheck',
    value: function resultCheck(method, res) {
      if (res.error) {
        return res;
      }

      if (!res || !res.data) {
        if (res.originValue) {
          return (0, _assign2.default)(_resultCode2.default.NET_ERR, { msgInfo: res.originValue, msgCode: res.ret });
        }
        return (0, _assign2.default)(_resultCode2.default.NET_ERR, { respond: res });
      }
      if (res.retType && res.retType !== 0) {
        var ret = res.ret;

        var ret_msgInfo = '';
        var ret_msgCode = '';
        if (ret[0].indexOf('::') > -1) {
          var msgArray = ret[0].split('::');
          ret_msgCode = msgArray[0];
          ret_msgInfo = msgArray[1];
        }
        return (0, _assign2.default)(_resultCode2.default.NET_ERR, { msgInfo: ret_msgInfo, msgCode: ret_msgCode });
      }
      if (res.data.success !== 'true') {
        var _res$data = res.data,
            msgInfo = _res$data.msgInfo,
            msgCode = _res$data.msgCode;

        return (0, _assign2.default)(_resultCode2.default.NET_ERR, { msgInfo: msgInfo, msgCode: msgCode });
      }

      if (res.data.success === 'true' && res.data.model) {
        var data = { model: res.data.model };
        if (res.data.extensions) {
          data.extensions = res.data.extensions;
        }
        return (0, _assign2.default)(_resultCode2.default.SUCCEED, data);
      }
      return res;
    }
    /**
     * 不同方法检查分发
     * @param {*} method 方法名
     * @param {*} res 接口返回信息
     * @param {*} secondInfo 二次待检查信息
     */

  }, {
    key: 'distributeCheck',
    value: function distributeCheck(method, res, secondInfo) {
      switch (method) {
        case 'getDeviceStatus':
          return this.getDeviceStatusResultCheck(res);
        case 'deviceControl':
          return this.deviceControlResultCheck(res, secondInfo);
        default:
          return 'NONE';
      }
    }
  }]);
  return JsBridge;
}();

exports.default = JsBridge;