'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 获取接口持续尝试
var tryToGetGgain = function tryToGetGgain(func) {
  var num = 0;
  var resute = '';
  // CC上重连调用
  if (my.getSystemInfoSync().app === 'GenieWebApps') {
    var timeOut = setInterval(function () {
      console.log('tryToGetGgain>>>&', num, resute);
      if (num > 2 || resute) {
        clearInterval(timeOut);
        return;
      }
      num += 1;
      func(function (info) {
        resute = info;
      });
    }, 1000);
  } else {
    func(function () {});
  }
};
exports.default = {
  // 获取设备状态
  getDeviceStatus: function getDeviceStatus() {
    var _this = this;

    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _Params$deviceInfo = this.Params.deviceInfo,
        devId = _Params$deviceInfo.devId,
        skillId = _Params$deviceInfo.skillId,
        productKey = _Params$deviceInfo.productKey;

    devId = params.devId || devId;
    skillId = params.skillId || skillId;
    productKey = params.productKey || productKey;
    console.log('获取设备状态 getDeviceStatus', devId, '*', productKey, skillId);
    return new _promise2.default(function (resolve, reject) {
      // 获取接口持续尝试
      tryToGetGgain(function (callback) {
        my.aiot.getDeviceStatus({
          deviceId: devId,
          skillId: skillId,
          productKey: productKey,
          success: function success(deviceStatus) {
            callback('success');
            // 更据物的模型，改变格式
            if (_this.baseData.deviceInfo && (0, _stringify2.default)(_this.baseData.deviceInfo) !== '{}') {
              var attributes = _this.baseData.deviceInfo.tsl.attributes;
              for (var name in deviceStatus.attr) {
                for (var i = 0; i < attributes.length; i++) {
                  if (attributes[i].attributeEn === name && name !== 'onlinestate') {
                    if (attributes[i].dataType.type === 'boolean' || attributes[i].dataType.type === 'int' || attributes[i].dataType.type === 'enum') {
                      deviceStatus.attr[name] = Number(deviceStatus.attr[name]);
                    }
                    break;
                  }
                }
              }
            }
            resolve({ model: deviceStatus });
          },
          fail: function fail(err) {
            callback('error');
            console.log('resute修改为error');
            err.msgInfo = err.msg || err.msgInfo;
            reject(err);
          }
        });
      });
    });
  },

  // 获取设备物的模型
  getProductTSL: function getProductTSL() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _Params$deviceInfo2 = this.Params.deviceInfo,
        devId = _Params$deviceInfo2.devId,
        skillId = _Params$deviceInfo2.skillId,
        productKey = _Params$deviceInfo2.productKey;

    devId = params.devId || devId;
    skillId = params.skillId || skillId;
    productKey = params.productKey || productKey;
    return new _promise2.default(function (resolve, reject) {
      // 获取接口持续尝试
      tryToGetGgain(function (callback) {
        my.aiot.getProductTSL({
          deviceId: devId,
          skillId: skillId,
          productKey: productKey,
          success: function success(res) {
            callback('success');
            resolve({ model: res });
          },
          fail: function fail(err) {
            callback('error');
            err.msgInfo = err.msg || err.msgInfo;
            reject(err);
          }
        });
      });
    });
  },

  // 控制设备
  controlDevice: function controlDevice(_ref) {
    var _ref$params = _ref.params,
        params = _ref$params === undefined ? '{}' : _ref$params;

    params = JSON.parse(params);
    var _Params$deviceInfo3 = this.Params.deviceInfo,
        devId = _Params$deviceInfo3.devId,
        skillId = _Params$deviceInfo3.skillId,
        productKey = _Params$deviceInfo3.productKey;

    devId = params.devId || devId;
    skillId = params.skillId || skillId;
    productKey = params.productKey || productKey;
    return new _promise2.default(function (resolve, reject) {
      // 获取接口持续尝试
      tryToGetGgain(function (callback) {
        my.aiot.controlDevice({
          deviceId: devId,
          skillId: skillId,
          method: 'thing.attribute.set',
          params: params.params || {},
          success: function success(res) {
            if (res) {
              console.log('控制成功了', (0, _stringify2.default)(res));
              resolve({ model: res });
            } else {
              reject({
                msgInfo: '控制设备失败了,请稍候在试'
              });
            }
          },
          fail: function fail(err) {
            err.msgInfo = err.msg || err.msgInfo;
            reject(err);
          }
        });
      });
    });
  },

  // 获取设备产品数据
  getProductInfo: function getProductInfo() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var productKey = this.Params.deviceInfo.productKey;

    productKey = params.productKey || productKey;
    return new _promise2.default(function (resolve, reject) {
      // 获取接口持续尝试
      tryToGetGgain(function (callback) {
        console.log('timetime', 'getProductInfo接口调用', new Date(), (new Date().getTime() + '').slice(10));
        my.aiot.getProductInfo({
          productKey: productKey,
          success: function success(res) {
            callback('success');
            console.log('timetime', 'getProductInfo接口获取调用了', new Date(), (new Date().getTime() + '').slice(10));
            resolve({ model: res });
          },
          fail: function fail(err) {
            err.msgInfo = err.msg || err.msgInfo;
            reject(err);
          }
        });
      });
    });
  },

  // 获取设备列表
  getAllDevices: function getAllDevices(_ref2) {
    var _ref2$params = _ref2.params,
        params = _ref2$params === undefined ? {} : _ref2$params;

    console.log('列表参数', (0, _stringify2.default)(params));
    return new _promise2.default(function (resolve, reject) {
      my.aiot.getDeviceList({
        appInfo: {
          "osVersion": "13.5.1",
          "appName": "天猫精灵",
          "deviceModel": "iPhone12,   8",
          "appVersion": "4.6.0.7",
          "platform": "iOS"
        },
        params: (0, _stringify2.default)(params),
        success: function success(ret) {
          resolve({ model: {
              devices: ret.devices || ret
            } });
        },
        fail: function fail(err) {
          err.msgInfo = err.msg || err.msgInfo;
          console.log('设备列表失败' + (0, _stringify2.default)(err));
          reject(err);
        }
      });
    });
  }
};