"use strict";

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

var _setPrototypeOf = require("babel-runtime/core-js/object/set-prototype-of");

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = _setPrototypeOf2.default || { __proto__: [] } instanceof Array && function (d, b) {
            d.__proto__ = b;
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? (0, _create2.default)(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
/**
 * 设备列表刷新间隔 ms
 */
var SYNC_INTERVAL = 3000;
var DeviceListAliPay = /** @class */function (_super) {
    __extends(DeviceListAliPay, _super);
    function DeviceListAliPay() {
        var _this_1 = _super.call(this) || this;
        _this_1.inSync = false;
        _this_1.syncDeviceListenerList = new Array();
        /**
         * 每次拉取设备列表都通知的列表
         */
        _this_1.deviceListenerList = new Array();
        return _this_1;
    }
    DeviceListAliPay.prototype.onDeviceListSync = function (listener) {
        if (this.deviceListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        } else {
            this.deviceListenerList.push(listener);
        }
        this.onDeviceListChange(listener);
    };
    DeviceListAliPay.prototype.onDeviceListChange = function (listener) {
        if (this.syncDeviceListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        } else {
            this.syncDeviceListenerList.push(listener);
        }
        if (this.inSync) {
            return;
        }
        this.log("start sync");
        this.inSync = true;
        this.syncDeviceInfoTask();
    };
    DeviceListAliPay.prototype.syncDeviceInfoTask = function () {
        var _this_1 = this;
        if (!this.inSync) {
            return;
        }
        var oldDeviceList = this.deviceCache;
        var _this = this;
        this.getDeviceList({
            appInfo: this.localAppInfo,
            success: function success() {
                _this_1.notifyDeviceListUpdate(_this, oldDeviceList);
            },
            complete: function complete() {
                setTimeout(function () {
                    _this_1.log("next loop");
                    _this_1.syncDeviceInfoTask();
                }, SYNC_INTERVAL);
            }
        });
    };
    DeviceListAliPay.prototype.notifyDeviceListUpdate = function (_this, oldDeviceList) {
        this.deviceListenerList.forEach(function (listener) {
            try {
                listener(_this.deviceCache);
            } catch (err) {
                console.error(err);
            }
        });
        var oldArr = {},
            newArr = {};
        oldArr = (0, _assign2.default)(oldArr, oldDeviceList);
        newArr = (0, _assign2.default)(newArr, _this.deviceCache);
        var changedArr = [];
        (0, _keys2.default)(oldArr).forEach(function (key) {
            if (newArr[key]) {
                delete newArr[key];
            } else {
                changedArr.push({
                    "devId": key,
                    "action": "delete"
                });
            }
        });
        (0, _keys2.default)(newArr).forEach(function (key) {
            changedArr.push({
                "devId": key,
                "action": "add"
            });
        });
        if (changedArr.length > 0) {
            this.syncDeviceListenerList.forEach(function (listener) {
                try {
                    listener(changedArr);
                } catch (err) {
                    console.error(err);
                }
            });
        }
    };
    DeviceListAliPay.prototype.offDeviceListChange = function (listener) {
        var index = this.syncDeviceListenerList.indexOf(listener);
        if (index == -1) {
            this.log('invalid listener');
            return;
        }
        this.syncDeviceListenerList.splice(index, 1);
        var index2 = this.deviceListenerList.indexOf(listener);
        if (index2 > -1) {
            this.deviceListenerList.splice(index2, 1);
        }
        if (this.syncDeviceListenerList.length == 0) {
            this.inSync = false;
            this.log("stop sync");
        } else {
            this.log("listener unregister.");
        }
    };
    return DeviceListAliPay;
}(index_1.DeviceList);
exports.DeviceListAliPay = DeviceListAliPay;
exports.default = new DeviceListAliPay();