"use strict";

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __importDefault = undefined && undefined.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_alipay_1 = __importDefault(require("../mtop/index.alipay"));
var API_NAME = 'mtop.alibaba.aicloud.iot.getAllDevicesForAlipay';
var API_VERSION = '1.0';
var PARAMS = {};
var DEVICE_INFO = '';
var DeviceCache = /** @class */function () {
    function DeviceCache() {}
    return DeviceCache;
}();
exports.DeviceCache = DeviceCache;
/**
 * 设备列表刷新间隔 ms
 */
var SYNC_INTERVAL = 3000;
var DeviceList = /** @class */function () {
    function DeviceList() {
        this.appInfoDefault = { "appName": "天猫精灵", "appVersion": "4.8.0", "deviceModel": "Pixel2", "osVersion": "google/walleye/walleye: 10/QP1A.191005.007.A1/5908163: user/release-keys", "platform": "Android" };
        this.localAppInfo = this.appInfoDefault;
        this._deviceCache = new DeviceCache();
    }
    Object.defineProperty(DeviceList.prototype, "deviceCache", {
        get: function get() {
            return this._deviceCache;
        },
        enumerable: true,
        configurable: true
    });
    DeviceList.prototype.getDeviceList = function (request) {
        var appInfo = request.appInfo;
        var _success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var self = this;
        if ((0, _stringify2.default)(appInfo) != (0, _stringify2.default)(this.localAppInfo)) {
            this.localAppInfo = appInfo;
        }
        index_alipay_1.default.sendMtop({
            api: API_NAME,
            v: API_VERSION,
            needLogin: true,
            data: {
                params: (0, _stringify2.default)(PARAMS),
                deviceInfo: DEVICE_INFO,
                appInfo: (0, _stringify2.default)(appInfo)
            },
            success: function success(ret) {
                self._handleResponse(ret, _success);
            },
            fail: fail,
            complete: complete
        });
    };
    ;
    DeviceList.prototype._handleResponse = function (ret, success) {
        // console.log('>> _handleResponse', JSON.stringify(ret));
        var _this = this;
        var devices = ret.devices,
            zones = ret.zones;
        this._deviceCache = new DeviceCache();
        devices.map(function (device) {
            var dev = device;
            _this._deviceCache[dev.devId.toLowerCase()] = dev;
        });
        success(devices);
    };
    ;
    DeviceList.prototype.onDeviceListChange = function (callback) {};
    DeviceList.prototype.offDeviceListChange = function (callback) {};
    DeviceList.prototype.log = function (msg) {
        console.log(msg);
    };
    return DeviceList;
}();
exports.DeviceList = DeviceList;
exports.default = new DeviceList();