"use strict";

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

var _setPrototypeOf = require("babel-runtime/core-js/object/set-prototype-of");

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = _setPrototypeOf2.default || { __proto__: [] } instanceof Array && function (d, b) {
            d.__proto__ = b;
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? (0, _create2.default)(b) : (__.prototype = b.prototype, new __());
    };
}();
var __importStar = undefined && undefined.__importStar || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) {
        if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    }result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = __importStar(require("./index"));
var DeviceListTG = /** @class */function (_super) {
    __extends(DeviceListTG, _super);
    function DeviceListTG() {
        var _this = _super.call(this) || this;
        _this.listenerList = new Array();
        my.on("onDeviceListChange", function (e) {
            var deviceCache = index_1.default.deviceCache;
            index_1.default.getDeviceList({
                appInfo: index_1.default.localAppInfo,
                success: function success(devices) {
                    _this.notifyDeviceListUpdate(deviceCache);
                }
            });
        });
        return _this;
    }
    DeviceListTG.prototype.onDeviceListChange = function (listener) {
        if (this.listenerList.indexOf(listener) != -1) {
            console.warn('duplicated listener');
            return;
        }
        this.listenerList.push(listener);
        my.call("getService", { sdkName: "DeviceMonitor", serviceName: "BoneAccsService", minSDKVer: "*" }, function (service) {
            my.call("callService", { serviceId: service.serviceId, methodName: "subscribe", args: [{ "name": "device_list_change" }] }, function (result) {
                console.log((0, _stringify2.default)(result));
                my.call("callContainer", { serviceName: "BoneEvent", args: [] }, function (data) {});
            });
        });
    };
    DeviceListTG.prototype.notifyDeviceListUpdate = function (oldDeviceList) {
        var oldArr = {},
            newArr = {};
        oldArr = (0, _assign2.default)(oldArr, oldDeviceList);
        newArr = (0, _assign2.default)(newArr, this.deviceCache);
        var changedArr = [];
        (0, _keys2.default)(oldArr).forEach(function (key) {
            if (newArr[key]) {
                delete newArr[key];
            } else {
                changedArr.push({
                    "devId": key,
                    "action": "delete"
                });
            }
        });
        (0, _keys2.default)(newArr).forEach(function (key) {
            changedArr.push({
                "devId": key,
                "action": "add"
            });
        });
        this.listenerList.forEach(function (listener) {
            listener(changedArr);
        });
    };
    DeviceListTG.prototype.offDeviceListChange = function (listener) {
        var index = this.listenerList.indexOf(listener);
        if (index == -1) {
            console.warn('invalid listener');
            return;
        }
        this.listenerList.splice(index, 1);
        if (this.listenerList.length == 0) {
            my.call("getService", { sdkName: "DeviceMonitor", serviceName: "BoneAccsService", minSDKVer: "*" }, function (service) {
                my.call("callService", { serviceId: service.serviceId, methodName: "unsubscribe", args: [{ "name": "device_list_change" }] }, function (result) {});
            });
        }
    };
    return DeviceListTG;
}(index_1.DeviceList);
exports.DeviceListTG = DeviceListTG;
exports.default = new DeviceListTG();