"use strict";

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

var _setPrototypeOf = require("babel-runtime/core-js/object/set-prototype-of");

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = _setPrototypeOf2.default || { __proto__: [] } instanceof Array && function (d, b) {
            d.__proto__ = b;
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? (0, _create2.default)(b) : (__.prototype = b.prototype, new __());
    };
}();
var __importDefault = undefined && undefined.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
var index_alipay_1 = __importDefault(require("../device-list/index.alipay"));
var TMPSDKAlipay = /** @class */function (_super) {
    __extends(TMPSDKAlipay, _super);
    function TMPSDKAlipay() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.syncListenerList = new Array();
        _this.oldDeviceListCache = index_alipay_1.default.deviceCache;
        _this.deviceListChangeListener = function (info) {
            // this.log(JSON.stringify(info));
            _this.notifyDeviceChange(_this.oldDeviceListCache, index_alipay_1.default.deviceCache);
        };
        return _this;
    }
    TMPSDKAlipay.prototype.onDeviceStatusChange = function (listener) {
        if (this.syncListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        } else {
            this.syncListenerList.push(listener);
            this.oldDeviceListCache = index_alipay_1.default.deviceCache;
            index_alipay_1.default.onDeviceListSync(this.deviceListChangeListener);
        }
    };
    TMPSDKAlipay.prototype.notifyDeviceChange = function (originArr, currentArr) {
        var _this = this;
        var SyncDeviceInfoArr = [];
        (0, _keys2.default)(currentArr).forEach(function (key) {
            var currentDevice = currentArr[key];
            var originDevice = originArr[key];
            if (currentDevice.screenModelFunctionParams && currentDevice.screenModelFunctionParams.status) {
                if (!originDevice || !originDevice.screenModelFunctionParams) {
                    _this.log("origin device is null");
                } else if (currentDevice.screenModelFunctionParams.status != originDevice.screenModelFunctionParams.status) {
                    SyncDeviceInfoArr.push({
                        action: "status_update",
                        attr: JSON.parse(currentDevice.screenModelFunctionParams.status),
                        deviceId: key
                    });
                } else {
                    _this.log("same");
                }
            } else {
                _this.log("不是iot设备");
            }
        });
        if (SyncDeviceInfoArr.length > 0) {
            this.syncListenerList.forEach(function (listener) {
                listener(SyncDeviceInfoArr);
            });
        }
        this.oldDeviceListCache = currentArr;
    };
    TMPSDKAlipay.prototype.isEquals = function (jsonStirng1, jsonString2) {
        //todo 精确比较
        return jsonStirng1 === jsonString2;
    };
    TMPSDKAlipay.prototype.offDeviceStatusChange = function (listener) {
        var index = this.syncListenerList.indexOf(listener);
        if (index == -1) {
            this.log('invalid listener');
            return;
        }
        this.syncListenerList.splice(index, 1);
        if (this.syncListenerList.length == 0) {
            index_alipay_1.default.offDeviceListChange(this.deviceListChangeListener);
        } else {
            this.log("listener unregister.");
        }
    };
    return TMPSDKAlipay;
}(index_1.TMPSDK);
exports.TMPSDKAlipay = TMPSDKAlipay;
;
exports.default = new TMPSDKAlipay();