"use strict";

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _getOwnPropertySymbols = require("babel-runtime/core-js/object/get-own-property-symbols");

var _getOwnPropertySymbols2 = _interopRequireDefault(_getOwnPropertySymbols);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof _getOwnPropertySymbols2.default === "function") for (var i = 0, p = (0, _getOwnPropertySymbols2.default)(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
    }
    return t;
};
var __importDefault = undefined && undefined.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tg_iot_interface_api_common_1 = require("@alife/tg-iot-interface-api-common");
var tg_iot_interface_api_device_panel_1 = require("@alife/tg-iot-interface-api-device-panel");
var index_cc_1 = __importDefault(require("./mtop/index.cc"));
var aiot = {
    sendMtop: index_cc_1.default.sendMtop.bind(index_cc_1.default)
};
// wrapp event "onSyncDeviceInfo"
var listenerList = new Array();
var onSyncDeviceInfo = function onSyncDeviceInfo(listener) {
    if (listenerList.indexOf(listener) != -1) {
        console.warn('duplicated listener');
        return;
    }
    listenerList.push(listener);
};
var offSyncDeviceInfo = function offSyncDeviceInfo(listener) {
    var index = listenerList.indexOf(listener);
    if (index == -1) {
        console.warn('invalid listener');
        return;
    }
    listenerList.splice(index, 1);
};
(0, _assign2.default)(aiot, { onSyncDeviceInfo: onSyncDeviceInfo, offSyncDeviceInfo: offSyncDeviceInfo });
var API_LIST = ['controlDevice', 'getDeviceStatus', 'getProductInfo', 'getProductTSL', 'deletedevice'];
API_LIST.forEach(function (method) {
    aiot[method] = function (options) {
        var success = options.success,
            fail = options.fail,
            complete = options.complete,
            args = __rest(options, ["success", "fail", "complete"]);
        // 控制设备时，默认 method 为设置属性
        if (method === 'controlDevice') {
            var controlMethod = args.method;
            if (!controlMethod) {
                (0, _assign2.default)(args, {
                    method: tg_iot_interface_api_device_panel_1.EMTHOD_ATTRIBUTE_SET
                });
            }
        }
        try {
            my.call("aiot_" + method, args, function (res) {
                var isSuccess = res.success,
                    model = res.model,
                    msgCode = res.msgCode,
                    msgInfo = res.msgInfo;
                if (isSuccess) {
                    var res_1 = JSON.parse(model);
                    success(res_1);
                    complete && complete(res_1);
                } else {
                    var err = {
                        code: msgCode,
                        msg: msgInfo
                    };
                    fail && fail(err);
                    complete && complete(res);
                }
            });
        } catch (err) {
            var apiError = {
                code: tg_iot_interface_api_common_1.ERROR_CODE,
                msg: (0, _stringify2.default)(err)
            };
            fail && fail(apiError);
            complete && complete(apiError);
        }
    };
});
var setupEventListener = function setupEventListener() {
    my.on('iot.syncDeviceInfo', function (msg) {
        console.log('>> iot.onDeviceListChanged for cc', (0, _stringify2.default)(msg));
        var syncDeviceInfo = msg;
        var data = syncDeviceInfo.data;
        if (!data) {
            console.warn('invalid DeviceStatusChangeMessage data');
            return;
        }
        var arrayData = data.data;
        if (!arrayData) {
            console.warn('invalid DeviceStatusChangeMessage array');
            return;
        }
        listenerList.forEach(function (listener) {
            listener(arrayData);
        });
    });
};
exports.steupEventListenerForCC = setupEventListener;
exports.default = aiot;