import mtop from '../mtop/index.alipay';
import { APIOptions } from '@alife/tg-iot-interface-api-common';

export interface BindDeviceOptions extends APIOptions {
    productKey: string;
    deviceName?: string;
    networkType?: string;
    token?: string;
}

class BindDevice {
    public bindDevice(options: BindDeviceOptions): void {
        const { productKey, deviceName, networkType, token, success, fail, complete } = options;

        mtop.sendMtop({
            api: 'mtop.alibaba.aicloud.iot.binddeviceForAlipay',
            v: '1.0',
            needLogin: true,
            data: {
                productKey,
                deviceName,
                networkType: networkType || 'wifi',
                token
            },
            success,
            fail,
            complete
        });
    }
}

export default new BindDevice();