import IDevicePanelAPI, { DSL } from '@iotfe/device-panel-interface-api-config-info';
import { gatewayAPI } from '../gateway';

const API_PATH_AEP_CONFIG_GET: string = '/iotx/aep/queryConfig';
const API_VERSION_AEP_CONFIG_GET: string = '1.0.3';

export default class DevicePanelAPI implements IDevicePanelAPI {
    public async getDSL(configVersionId: string): Promise<DSL> {
        return await gatewayAPI.request(API_PATH_AEP_CONFIG_GET, {
            apiVer: API_VERSION_AEP_CONFIG_GET,
            data: {
                configVersionId,
            }
        });
    }
};
