import IGatewayAPI, { HTTPMethod, APIGatewayOptions } from '@iotfe/device-panel-interface-api-gateway';
import http from '@ali/ilop-mini-biz-sdk';

const APIGatewayDefaults: APIGatewayOptions = {
    apiVer: '1.0.0',
    method: HTTPMethod.POST,
    protocol: 'https',
    language: 'zh-CN',
    data: {},
};

export default class GatewayAPI implements IGatewayAPI {
    public async request(path: string, option: APIGatewayOptions): Promise<any> {
        option = Object.assign({}, APIGatewayDefaults, option);
        const { apiVer, method, headers, data,language } = option;
        return await http.request(path, data, { method, headers, language, apiVersion: apiVer});
    }
};

export const gatewayAPI = new GatewayAPI();