import mtop from './mtop/index.alipay';
import devicePanel from './device-panel/index.tg';
import deviceList from './device-list/index.tg';
import { device } from '@alife/aiot-tmp-sdk';

export { mtop, devicePanel, deviceList };

const { app, model, version } = my.getSystemInfoSync();

const _aiot = {
    sendMtop: mtop.sendMtop.bind(mtop),
    getDeviceList: deviceList.getDeviceList.bind(deviceList),
    onDeviceListChange: deviceList.onDeviceListChange.bind(deviceList),
    offDeviceListChange: deviceList.offDeviceListChange.bind(deviceList),
    controlDevice: devicePanel.controlDevice.bind(devicePanel),
    controlMeshDevice: devicePanel.controlMeshDevice.bind(devicePanel),
    getDeviceStatus: devicePanel.getDeviceStatus.bind(devicePanel),
    getDeviceConnectStatus: devicePanel.getDeviceConnectStatus.bind(devicePanel),
    getProductInfo: devicePanel.getProductInfo.bind(devicePanel),
    getProductTSL: devicePanel.getProductTSL.bind(devicePanel),
    deleteDevice: devicePanel.deleteDevice.bind(devicePanel),
    onSyncDeviceInfo: devicePanel.onDeviceStatusChange.bind(devicePanel),
    offSyncDeviceInfo: devicePanel.offDeviceStatusChange.bind(devicePanel)
};

const tmpSdk = {
    startLocalConnect:  device.startLocalConnect.bind(device),
    stopLocalConnect:  device.stopLocalConnect.bind(device),
    controlDevice: device.controlDevice.bind(device),
    getDeviceStatus: device.getDeviceStatus.bind(device),
    getProductInfo: device.getProductInfo.bind(device),
    getProductTSL: device.getProductTSL.bind(device),
    deleteDevice: device.deleteDevice.bind(device),
    getDeviceConnectStatus: device.getDeviceConnectStatus.bind(device),
    getDeviceDetail: device.getDeviceDetail.bind(device),
    onConnectStatusChange: device.onConnectStatusChange.bind(device),
    onDeviceStatusChange: device.onDeviceStatusChange.bind(device),
    onGenieBoxStatusChange: device.onGenieBoxStatusChange.bind(device),
    onDeviceControlChange: device.onDeviceControlChange.bind(device),
    onBluetoothStateChange: device.onBluetoothStateChange.bind(device),
};

let aiot = {..._aiot };

if(app === 'TGenie' && version >= '5.3') {
    aiot = {..._aiot, ...tmpSdk};
}

declare let my: any;
Object.assign(my, { aiot });

export default aiot;