declare const my:any;

import aiotForAlipay from './index.alipay';
import aiotForTG from './index.tg';
import aiotForCC, { steupEventListenerForCC } from './index.cc';
import aiotForRTOS,  { steupEventListenerForRTOS } from './index.rtos';

(function(){

    // 防止重复挂载
    if(my.aiot){
        return;
    }

    const { app, model, version } = my.getSystemInfoSync();
    console.log('>> initialize my.aiot for', `${app}@${version}`, model);
    // 各个已知客户端的 app 取值
    // 支付宝: "alipay"
    // 猫精: "TGenie"
    // 猫精CC: "genie", "GenieWebApps"
    // 猫精二郎神: "UNKNOWN"
    
    if (app === 'UNKNOWN' && model === 'AliOSThings') {
        Object.assign(my, {
            aiot: aiotForRTOS
        });
        steupEventListenerForRTOS();
    } else if (app === 'genie' || app === 'GenieWebApps' ||(app !== 'TGenie' && model.indexOf('AILABS') >= 0)) {
        Object.assign(my, {
            aiot: aiotForCC
        });
        steupEventListenerForCC();
    } else if (app === 'TGenie') {
        Object.assign(my, {
            aiot: aiotForTG,
        });
    } else {
        Object.assign(my, {
            aiot: aiotForAlipay
        });
    }
})();
