import IAddDeviceAPI, { StartAddDeviceOptions, StopAddDeviceOptions, AddDeviceStatus } from '@alife/tg-iot-interface-api-add-device';
declare class AddDevice implements IAddDeviceAPI {
    private _currentStatus;
    private _listenerManager;
    get currentAddDeviceStatus(): AddDeviceStatus;
    constructor();
    /**
     * 开始添加设备
     * @param options 开始添加设备的信息描述
     */
    startAddDevice(options: StartAddDeviceOptions): void;
    /**
     * 停止添加设备
     * @param options 停止添加设备的信息描述
     */
    stopAddDevice(options: StopAddDeviceOptions): void;
    /**
     * 开始监听设备添加过程变化
     * @param listener 监听器
     */
    onAddDeviceStatusChagne(listener: (status: AddDeviceStatus) => void): void;
    /**
     * 停止监听设备添加过程变化
     * @param listener 需要停止监听的监听器; 若为空，则停止所有监听器
     */
    offAddDeviceStatusChange(listener?: (status: AddDeviceStatus) => void): void;
    /**
     * 进行配网
     * @param productKey 待配网的产品
     * @param token 产品的配网秘钥
     * @param success 成功回调
     * @param fail 失败回调
     * @param complte 完成回调
     */
    private _doProvision;
    /**
     * 绑定设备
     * @param productKey 待绑定的产品
     * @param deviceName 待绑定的设备名称
     * @param token 待绑定的 token
     */
    private _doBind;
    /**
     * 触发监听器
     */
    private _notifyListeners;
}
declare const _default: AddDevice;
export default _default;
