'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tools = function () {
  function Tools() {
    (0, _classCallCheck3.default)(this, Tools);
  }

  (0, _createClass3.default)(Tools, [{
    key: 'urlParam',

    // 获取页面参数
    value: function urlParam() {
      var val = void 0;
      var href = window.location.href.split('?')[1] || '';
      href = href.split('&');

      var data = {
        urlParamVal: 0
      };
      for (var i = 0; i < href.length; i += 1) {
        val = href[i].split('=');
        if (val[1]) {
          data[val[0]] = decodeURIComponent(val[1]);
          data.urlParamVal += 1;
        }
      }
      return data;
    }

    // 返回上一页面

  }, {
    key: 'goBack',
    value: function goBack() {
      if (getCurrentPages().length <= 1) {
        this.pageDisAppearParams && this.commitHit(this.pageDisAppearParams);
        this.closeMiniProgram();
      } else {
        my.navigateBack();
      }
    }

    // 关闭小程序

  }, {
    key: 'closeMiniProgram',
    value: function closeMiniProgram() {
      my.call("exitApp", {}, function (res) {});
    }

    // 打开外部页面的链接

  }, {
    key: 'openUrl',
    value: function openUrl(url) {
      this.jsBridge('common.pageRouter.openUrl', {
        url: url
      });
    }

    // 判断手机为Andriod

  }, {
    key: 'isAndriod',
    value: function isAndriod() {
      return my.getSystemInfoSync().platform === 'Android';
    }

    // 判断手机为IOS

  }, {
    key: 'isIos',
    value: function isIos() {
      return my.getSystemInfoSync().platform === 'iOS';
    }

    // 设置navbar返回事件兼听

  }, {
    key: 'setNavbarBack',
    value: function setNavbarBack() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      this.navbarBackListen = '';
      if (callback && typeof callback === 'function') {
        this.navbarBackListen = callback;
      }
    }

    // navbar返回

  }, {
    key: 'navbarBack',
    value: function navbarBack() {
      var _this = this;

      my.on('SmartSceneBackBtnClickEvent', function () {
        if (_this.navbarBackListen) {
          _this.navbarBackListen();
        } else {
          _this.goBack();
        }
      });
    }
  }, {
    key: 'setBaseSpm',
    value: function setBaseSpm(pageName, spm, type, eventName) {
      var props = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

      console.error(this.container, '埋点数据：', pageName, spm, type, eventName, (0, _stringify2.default)((0, _extends3.default)({}, this.spmParamsData, props)));
      if (this.container !== 'erlang') {
        // 页面进入
        this.commitHit({
          page_name: pageName,
          spm: spm,
          type: type,
          event_name: eventName,
          props: (0, _extends3.default)({}, this.spmParamsData, props)
        });
      } else {
        this.record(this.spmA, this.spmB, { page_name: pageName, d: props.eventName }, (0, _extends3.default)({}, this.spmParamsData, props, {
          type: type, event_name: eventName
        }), eventName);
      }
    }

    // 埋点方法

  }, {
    key: 'commitHit',
    value: function commitHit(_ref) {
      var page_name = _ref.page_name,
          spm = _ref.spm,
          type = _ref.type,
          event_name = _ref.event_name,
          props = _ref.props;

      console.error('***' + (0, _stringify2.default)({
        type: type,
        param: {
          event_name: props.spmA + '.' + props.spmB + '.' + event_name,
          spm: spm, //当前页面spm
          page_name: page_name, //当前页面名称
          props: props
        }
      }));
      //页面展示
      my.call('commitHit', {
        type: type,
        param: {
          event_name: props.spmA + '.' + props.spmB + '.' + event_name,
          spm: spm, //当前页面spm
          page_name: page_name, //当前页面名称
          props: props
        }
      }, function (result) {
        console.log('\u57CB\u70B9\u8FD4\u56DE ' + page_name + ' ====>', (0, _stringify2.default)(result));
      });
    }

    // 第一个页面，离开页面调用 pageDisAppear 事件

  }, {
    key: 'firstPageOnUnload',
    value: function firstPageOnUnload(params) {
      this.pageDisAppearParams = params;
    }

    // 设置

  }, {
    key: 'setNavbar',
    value: function setNavbar(_ref2) {
      var _ref2$text = _ref2.text,
          text = _ref2$text === undefined ? '' : _ref2$text,
          _ref2$icon = _ref2.icon,
          icon = _ref2$icon === undefined ? '' : _ref2$icon,
          _ref2$title = _ref2.title,
          title = _ref2$title === undefined ? '' : _ref2$title,
          _ref2$callback = _ref2.callback,
          callback = _ref2$callback === undefined ? function () {} : _ref2$callback;

      // 设置用侧
      var event = 'rightItemClick' + Date.parse(new Date());
      var data = {
        event: event,
        icon: icon,
        text: text
        // 设置title
      };if (title) {
        my.setNavigationBar({
          title: title
        });
      }
      if (!icon && !text) return;

      !data.icon && (data.icon = '');
      if (this.isIos() && text) {
        data.icon = 'text:' + text;
      }
      // console.error('navbar参数', data)
      my.call('setRightItem', data, function (res) {});

      my.on(event, callback);
    }

    // 获取2个数值之间的随机数

  }, {
    key: 'random',
    value: function random(min, max) {
      if (max == null) {
        max = min;
        min = 0;
      }
      return min + Math.floor(Math.random() * (max - min + 1));
    }

    // 属性值按物模型校验

  }, {
    key: 'checkAttribute',
    value: function checkAttribute(deviceStatus) {
      console.log('this.baseData.deviceInfo***', this.baseData && this.baseData.deviceInfo);
      if (this.baseData.deviceInfo && (0, _stringify2.default)(this.baseData.deviceInfo) !== '{}') {
        var attributes = this.baseData.deviceInfo.tsl.attributes;
        for (var name in deviceStatus.attr) {
          for (var i = 0; i < attributes.length; i++) {
            if (attributes[i].attributeEn === name) {
              if (attributes[i].dataType.type === 'boolean' || attributes[i].dataType.type === 'int' || attributes[i].dataType.type === 'enum') {
                deviceStatus.attr[name] = Number(deviceStatus.attr[name]);
              }
              break;
            }
          }
        }
      }
    }
  }]);
  return Tools;
}();

exports.default = Tools;