// 获取接口持续尝试
const tryToGetGgain = function(func) {
  let num = 0;
  let resute = ''
  // CC上重连调用
  if (my.getSystemInfoSync().app === 'GenieWebApps') {
    const timeOut = setInterval(() => {
      console.log('tryToGetGgain>>>&', num, resute)
      if (num > 2 || resute) {
        clearInterval(timeOut)
        return
      }
      num += 1
      func((info) => {
        resute = info
      })
    }, 1000)
  } else {
    func(() => {})
  }
}
export default {
  // 获取设备状态
  getDeviceStatus(params = {}) {
    let { devId, skillId, productKey } = this.Params.deviceInfo
    devId = params.devId || devId
    skillId = params.skillId || skillId;
    productKey = params.productKey || productKey
    console.log('获取设备状态 getDeviceStatus', devId, '*', productKey, skillId)
    return new Promise((resolve, reject) => {
      // 获取接口持续尝试
      tryToGetGgain((callback) => {
        my.aiot.getDeviceStatus({
          deviceId: devId,
          skillId,
          productKey,
          success: (deviceStatus)=>{
            callback('success')
            // 更据物的模型，改变格式
            if (this.baseData.deviceInfo && JSON.stringify(this.baseData.deviceInfo) !== '{}') {
              const attributes = this.baseData.deviceInfo.tsl.attributes
              for (let name in deviceStatus.attr) {
                for (let i = 0; i < attributes.length; i ++) {
                  if (attributes[i].attributeEn === name && name !== 'onlinestate') {
                    if (attributes[i].dataType.type === 'boolean' || attributes[i].dataType.type === 'int' || attributes[i].dataType.type === 'enum') {
                      deviceStatus.attr[name] = Number(deviceStatus.attr[name])
                    }
                    break;
                  }
                }
              }
            }
            resolve({ model: deviceStatus})
          },
          fail: (err)=>{
            callback('error')
            console.log('resute修改为error')
            err.msgInfo = err.msg || err.msgInfo
            reject(err)
          }
        })
      })
      
    })
  },
  // 获取设备物的模型
  getProductTSL(params = {}) {
    var { devId, skillId, productKey } = this.Params.deviceInfo;
    devId = params.devId || devId
    skillId = params.skillId || skillId;
    productKey = params.productKey || productKey
    return new Promise((resolve, reject) => {
      // 获取接口持续尝试
      tryToGetGgain((callback) => {
        my.aiot.getProductTSL({
          deviceId: devId,
          skillId,
          productKey,
          success: (res)=>{
            callback('success')
            resolve({ model: res })
          },
          fail: (err)=>{
            callback('error')
            err.msgInfo = err.msg || err.msgInfo
            reject(err)
          }
        });
      })
    })
  },
  // 控制设备
  controlDevice({params = '{}'}) {
    params = JSON.parse(params)
    let { devId, skillId, productKey } = this.Params.deviceInfo
    devId = params.devId || devId
    skillId = params.skillId || skillId
    productKey = params.productKey || productKey
    return new Promise((resolve, reject) => {
      // 获取接口持续尝试
      tryToGetGgain((callback) => {
        my.aiot.controlDevice({
          deviceId: devId,
          skillId,
          method: 'thing.attribute.set',
          params: params.params || {},
          success: (res) => {
            if (res) {
              console.log('控制成功了', JSON.stringify(res))
              resolve({ model: res })
            } else {
              reject({
                msgInfo: '控制设备失败了,请稍候在试'
              })
            }
          },
          fail: (err) => {
            err.msgInfo = err.msg || err.msgInfo
            reject(err)
          }
        })
      })
    })
  },
  // 获取设备产品数据
  getProductInfo(params = {}) {
    let { productKey } = this.Params.deviceInfo
    productKey = params.productKey || productKey
    return new Promise((resolve, reject) => {
      // 获取接口持续尝试
      tryToGetGgain((callback) => {
        console.log('timetime', 'getProductInfo接口调用', new Date(), ((new Date().getTime()) + '').slice(10))
        my.aiot.getProductInfo({
          productKey,
          success: (res) => {
            callback('success')
            console.log('timetime', 'getProductInfo接口获取调用了', new Date(), ((new Date().getTime()) + '').slice(10))
            resolve({ model: res })
          },  
          fail: (err) => {
            err.msgInfo = err.msg || err.msgInfo
            reject(err)
          }
        });
      })
    })
  },
  // 获取设备列表
  getAllDevices({params = {}}) {
    console.log('列表参数', JSON.stringify(params))
    return new Promise((resolve, reject) => {
      my.aiot.getDeviceList({
        appInfo: {
          "osVersion": "13.5.1",
          "appName": "天猫精灵",
          "deviceModel": "iPhone12,   8",
          "appVersion": "4.6.0.7",
          "platform": "iOS"
        },
        params: JSON.stringify(params),
        success: (ret) => {
          resolve({ model: {
            devices: ret.devices || ret
          } })
        },
        fail: (err)=>{
          err.msgInfo = err.msg || err.msgInfo
          console.log('设备列表失败' + JSON.stringify(err))
          reject(err)
        }
      });
    })
  },
  
}