// 设备全局的标准错误码
/**
 * type = succeed: 接口请求成功
 * type = error: 接口error，请求不通过
 * type = warning: 接口请求通过，但存在警告
 */
const RESULT_CODE = {
  SUCCEED: {
    type: 'succeed',
    code: 'SUCCEED',
    msg: '调用成功'
  },
  NET_ERR: {
    type: 'error',
    code: 'NET_ERR',
    msg: '网络异常'
  },
  DEV_ERR: {
    type: 'error',
    code: 'DEV_ERR',
    msg: '设备连接异常'
  },
  DEV_NOT: {
    type: 'warning',
    code: 'DEV_NOT',
    msg: '设备未激活'
  },
  DEV_OFF: {
    type: 'warning',
    code: 'DEV_OFF',
    msg: '设备离线'
  },
  DEV_DIS: {
    type: 'warning',
    code: 'DEV_DIS',
    msg: '设备禁用'
  },
  DEV_ABN: {
    type: 'warning',
    code: 'DEV_ABN',
    msg: '设备故障'
  },
  SET_ERR: {
    type: 'error',
    code: 'SET_ERR',
    msg: '属性设置异常'
  },
  SET_FAIL: {
    type: 'warning',
    code: 'SET_FAIL',
    msg: '属性设置失败'
  }
}

export default RESULT_CODE
