"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
/**
 * 设备列表刷新间隔 ms
 */
var SYNC_INTERVAL = 3000;
var DeviceListAliPay = /** @class */ (function (_super) {
    __extends(DeviceListAliPay, _super);
    function DeviceListAliPay() {
        var _this_1 = _super.call(this) || this;
        _this_1.inSync = false;
        _this_1.syncDeviceListenerList = new Array();
        /**
         * 每次拉取设备列表都通知的列表
         */
        _this_1.deviceListenerList = new Array();
        return _this_1;
    }
    DeviceListAliPay.prototype.onDeviceListSync = function (listener) {
        if (this.deviceListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        }
        else {
            this.deviceListenerList.push(listener);
        }
        this.onDeviceListChange(listener);
    };
    DeviceListAliPay.prototype.onDeviceListChange = function (listener) {
        if (this.syncDeviceListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        }
        else {
            this.syncDeviceListenerList.push(listener);
        }
        if (this.inSync) {
            return;
        }
        this.log("start sync");
        this.inSync = true;
        this.syncDeviceInfoTask();
    };
    DeviceListAliPay.prototype.syncDeviceInfoTask = function () {
        var _this_1 = this;
        if (!this.inSync) {
            return;
        }
        var oldDeviceList = this.deviceCache;
        var _this = this;
        this.getDeviceList({
            appInfo: this.localAppInfo,
            success: function () {
                _this_1.notifyDeviceListUpdate(_this, oldDeviceList);
            },
            complete: function () {
                setTimeout(function () {
                    _this_1.log("next loop");
                    _this_1.syncDeviceInfoTask();
                }, SYNC_INTERVAL);
            }
        });
    };
    DeviceListAliPay.prototype.notifyDeviceListUpdate = function (_this, oldDeviceList) {
        this.deviceListenerList.forEach(function (listener) {
            try {
                listener(_this.deviceCache);
            }
            catch (err) {
                console.error(err);
            }
        });
        var oldArr = {}, newArr = {};
        oldArr = Object.assign(oldArr, oldDeviceList);
        newArr = Object.assign(newArr, _this.deviceCache);
        var changedArr = [];
        Object.keys(oldArr).forEach(function (key) {
            if (newArr[key]) {
                delete newArr[key];
            }
            else {
                changedArr.push({
                    "devId": key,
                    "action": "delete"
                });
            }
        });
        Object.keys(newArr).forEach(function (key) {
            changedArr.push({
                "devId": key,
                "action": "add"
            });
        });
        if (changedArr.length > 0) {
            this.syncDeviceListenerList.forEach(function (listener) {
                try {
                    listener(changedArr);
                }
                catch (err) {
                    console.error(err);
                }
            });
        }
    };
    DeviceListAliPay.prototype.offDeviceListChange = function (listener) {
        var index = this.syncDeviceListenerList.indexOf(listener);
        if (index == -1) {
            this.log('invalid listener');
            return;
        }
        this.syncDeviceListenerList.splice(index, 1);
        var index2 = this.deviceListenerList.indexOf(listener);
        if (index2 > -1) {
            this.deviceListenerList.splice(index2, 1);
        }
        if (this.syncDeviceListenerList.length == 0) {
            this.inSync = false;
            this.log("stop sync");
        }
        else {
            this.log("listener unregister.");
        }
    };
    return DeviceListAliPay;
}(index_1.DeviceList));
exports.DeviceListAliPay = DeviceListAliPay;
exports.default = new DeviceListAliPay();
