"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = __importStar(require("./index"));
var DeviceListTG = /** @class */ (function (_super) {
    __extends(DeviceListTG, _super);
    function DeviceListTG() {
        var _this = _super.call(this) || this;
        _this.listenerList = new Array();
        my.on("onDeviceListChange", function (e) {
            var deviceCache = index_1.default.deviceCache;
            index_1.default.getDeviceList({
                appInfo: index_1.default.localAppInfo,
                success: function (devices) {
                    _this.notifyDeviceListUpdate(deviceCache);
                }
            });
        });
        return _this;
    }
    DeviceListTG.prototype.onDeviceListChange = function (listener) {
        if (this.listenerList.indexOf(listener) != -1) {
            console.warn('duplicated listener');
            return;
        }
        this.listenerList.push(listener);
        my.call("getService", { sdkName: "DeviceMonitor", serviceName: "BoneAccsService", minSDKVer: "*" }, function (service) {
            my.call("callService", { serviceId: service.serviceId, methodName: "subscribe", args: [{ "name": "device_list_change" }] }, function (result) {
                console.log(JSON.stringify(result));
                my.call("callContainer", { serviceName: "BoneEvent", args: [] }, (function (data) { }));
            });
        });
    };
    DeviceListTG.prototype.notifyDeviceListUpdate = function (oldDeviceList) {
        var oldArr = {}, newArr = {};
        oldArr = Object.assign(oldArr, oldDeviceList);
        newArr = Object.assign(newArr, this.deviceCache);
        var changedArr = [];
        Object.keys(oldArr).forEach(function (key) {
            if (newArr[key]) {
                delete newArr[key];
            }
            else {
                changedArr.push({
                    "devId": key,
                    "action": "delete"
                });
            }
        });
        Object.keys(newArr).forEach(function (key) {
            changedArr.push({
                "devId": key,
                "action": "add"
            });
        });
        this.listenerList.forEach(function (listener) {
            listener(changedArr);
        });
    };
    DeviceListTG.prototype.offDeviceListChange = function (listener) {
        var index = this.listenerList.indexOf(listener);
        if (index == -1) {
            console.warn('invalid listener');
            return;
        }
        this.listenerList.splice(index, 1);
        if (this.listenerList.length == 0) {
            my.call("getService", { sdkName: "DeviceMonitor", serviceName: "BoneAccsService", minSDKVer: "*" }, function (service) {
                my.call("callService", { serviceId: service.serviceId, methodName: "unsubscribe", args: [{ "name": "device_list_change" }] }, function (result) { });
            });
        }
    };
    return DeviceListTG;
}(index_1.DeviceList));
exports.DeviceListTG = DeviceListTG;
exports.default = new DeviceListTG();
