"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
var index_alipay_1 = __importDefault(require("../device-list/index.alipay"));
var TMPSDKAlipay = /** @class */ (function (_super) {
    __extends(TMPSDKAlipay, _super);
    function TMPSDKAlipay() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.syncListenerList = new Array();
        _this.oldDeviceListCache = index_alipay_1.default.deviceCache;
        _this.deviceListChangeListener = function (info) {
            // this.log(JSON.stringify(info));
            _this.notifyDeviceChange(_this.oldDeviceListCache, index_alipay_1.default.deviceCache);
        };
        return _this;
    }
    TMPSDKAlipay.prototype.onDeviceStatusChange = function (listener) {
        if (this.syncListenerList.indexOf(listener) != -1) {
            this.log("duplicate sync call.");
        }
        else {
            this.syncListenerList.push(listener);
            this.oldDeviceListCache = index_alipay_1.default.deviceCache;
            index_alipay_1.default.onDeviceListSync(this.deviceListChangeListener);
        }
    };
    TMPSDKAlipay.prototype.notifyDeviceChange = function (originArr, currentArr) {
        var _this = this;
        var SyncDeviceInfoArr = [];
        Object.keys(currentArr).forEach(function (key) {
            var currentDevice = currentArr[key];
            var originDevice = originArr[key];
            if (currentDevice.screenModelFunctionParams && currentDevice.screenModelFunctionParams.status) {
                if (!originDevice || !originDevice.screenModelFunctionParams) {
                    _this.log("origin device is null");
                }
                else if (currentDevice.screenModelFunctionParams.status != originDevice.screenModelFunctionParams.status) {
                    SyncDeviceInfoArr.push({
                        action: "status_update",
                        attr: JSON.parse(currentDevice.screenModelFunctionParams.status),
                        deviceId: key
                    });
                }
                else {
                    _this.log("same");
                }
            }
            else {
                _this.log("不是iot设备");
            }
        });
        if (SyncDeviceInfoArr.length > 0) {
            this.syncListenerList.forEach(function (listener) {
                listener(SyncDeviceInfoArr);
            });
        }
        this.oldDeviceListCache = currentArr;
    };
    TMPSDKAlipay.prototype.isEquals = function (jsonStirng1, jsonString2) {
        //todo 精确比较
        return jsonStirng1 === jsonString2;
    };
    TMPSDKAlipay.prototype.offDeviceStatusChange = function (listener) {
        var index = this.syncListenerList.indexOf(listener);
        if (index == -1) {
            this.log('invalid listener');
            return;
        }
        this.syncListenerList.splice(index, 1);
        if (this.syncListenerList.length == 0) {
            index_alipay_1.default.offDeviceListChange(this.deviceListChangeListener);
        }
        else {
            this.log("listener unregister.");
        }
    };
    return TMPSDKAlipay;
}(index_1.TMPSDK));
exports.TMPSDKAlipay = TMPSDKAlipay;
;
exports.default = new TMPSDKAlipay();
