"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tg_iot_interface_api_device_panel_1 = require("@alife/tg-iot-interface-api-device-panel");
var SDK_NAME = 'BoneTmpSDK';
var SERVICE_NAME = 'BoneTmpService';
var TMPSDKTG = /** @class */ (function () {
    function TMPSDKTG() {
        var _this = this;
        this.listenerList = new Array();
        /**
         * 预取 serviceId
         */
        this.getServiceIdAsync(function (serviceId) {
            _this.serviceId = serviceId;
        });
        /**
         * 监听设备变化状态
         */
        my.on("iot.syncDeviceInfo", function (e) {
            _this.listenerList.forEach(function (listener) {
                listener(e);
            });
        });
    }
    TMPSDKTG.prototype.controlDevice = function (request) {
        var deviceId = request.deviceId;
        var method = request.method;
        var params = request.params;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        if (!method
            || (tg_iot_interface_api_device_panel_1.EMTHOD_ATTRIBUTE_SET !== method && tg_iot_interface_api_device_panel_1.EMTHOD_SERVICE_INVOKE !== method)) {
            throw new Error('method is invalid');
        }
        if (!params) {
            throw new Error('params is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'controlDevice',
                    args: [
                        deviceId,
                        skillId,
                        method,
                        params,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    /**
     * 蓝牙 Mesh 设备专属控制接口
     * <p/>
     * 一方接口，仅限内部使用
     * @param request 请求描述
     */
    TMPSDKTG.prototype.controlMeshDevice = function (request) {
        var deviceId = request.deviceId;
        var params = request.params;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        if (!params) {
            throw new Error('params is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'controlMeshDevice',
                    args: [
                        deviceId,
                        skillId,
                        params,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    TMPSDKTG.prototype.getDeviceStatus = function (request) {
        var deviceId = request.deviceId;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'getDeviceStatus',
                    args: [
                        deviceId,
                        skillId,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    TMPSDKTG.prototype.getProductInfo = function (request) {
        var productKey = request.productKey;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        if (!productKey) {
            throw new Error('productKey is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'getProductInfo',
                    args: [
                        productKey,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    TMPSDKTG.prototype.getProductTSL = function (request) {
        var deviceId = request.deviceId;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'getProductTSL',
                    args: [
                        deviceId,
                        skillId,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    TMPSDKTG.prototype.onDeviceStatusChange = function (listener) {
        if (this.listenerList.indexOf(listener) != -1) {
            console.warn('duplicated listener');
            return;
        }
        this.listenerList.push(listener);
    };
    TMPSDKTG.prototype.offDeviceStatusChange = function (listener) {
        var index = this.listenerList.indexOf(listener);
        if (index == -1) {
            console.warn('invalid listener');
            return;
        }
        this.listenerList.splice(index, 1);
    };
    TMPSDKTG.prototype.deleteDevice = function (request) {
        var deviceId = request.deviceId;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'deleteDevice',
                    args: [
                        deviceId,
                        skillId,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    TMPSDKTG.prototype.getDeviceConnectStatus = function (request) {
        var deviceId = request.deviceId;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        var skillId = request.skillId;
        if (!deviceId) {
            throw new Error('deviceId is invalid');
        }
        this.getServiceIdAsync(function (serviceId) {
            try {
                my.call('callService', {
                    serviceId: serviceId,
                    methodName: 'getDeviceConnectStatus',
                    args: [
                        deviceId,
                        skillId,
                    ],
                }, function (result) {
                    success(result);
                    complete && complete(result);
                });
            }
            catch (err) {
                fail && fail(err);
                complete && complete(err);
            }
        });
    };
    ;
    /**
     * 获取需要的 serviceId
     * @param callback 获得到 serviceId 后的回调
     */
    TMPSDKTG.prototype.getServiceIdAsync = function (callback) {
        if (this.serviceId) {
            callback && callback(this.serviceId);
        }
        else {
            my.call("getService", { sdkName: SDK_NAME, serviceName: SERVICE_NAME, minSDKVer: "*" }, function (service) { callback && callback(service.serviceId); });
        }
    };
    return TMPSDKTG;
}());
exports.TMPSDKTG = TMPSDKTG;
;
exports.default = new TMPSDKTG();
