"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaultRequest = {
    api: '',
    v: '1.0',
    data: {},
    needLogin: false,
    success: function (ret) {
        console.warn('unhandled response:', JSON.stringify(ret));
    }
};
var MTop = /** @class */ (function () {
    function MTop() {
        this._debug = true;
    }
    MTop.prototype.setDebug = function (debug) {
        this._debug = debug;
    };
    MTop.prototype.sendMtop = function (request) {
        var _this = this;
        // 添加默认值
        request = Object.assign({}, defaultRequest, request);
        var api = request.api;
        var v = request.v;
        var needLogin = request.needLogin || false;
        var data = request.data;
        var success = request.success;
        var fail = request.fail;
        var complete = request.complete;
        if (!api) {
            throw new Error('api is invalid');
        }
        if (!v) {
            throw new Error('v is invalid');
        }
        try {
            if (this._debug) {
                console.log('>> before send mtop', api, v, needLogin, data);
            }
            my.call("mtopProxy", {
                eventNs: "AliGenie.API",
                eventName: "Mtop",
                payload: {
                    data: data,
                    v: v,
                    api: api,
                }
            }, function (res) {
                if (_this._debug) {
                    console.log('>> after send mtop', JSON.stringify(res));
                }
                res = res.payload;
                res.data = res.data || {};
                res.ret = res.ret || [];
                if (res.retType === 0 || res['ret'][0] === 'SUCCESS::调用成功' || res.data.statusCode === '200' || res.data.success === 'true') {
                    success(res.data.model);
                    complete && complete(res.data.model);
                }
                else {
                    var responseError = {
                        code: res.data.msgCode,
                        msg: res.data.msgInfo,
                    };
                    // 从 ret 中获取 errorCode
                    if (!responseError.code) {
                        var retMessage = res.ret[0];
                        var messageArr = retMessage.split('::');
                        Object.assign(responseError, {
                            code: messageArr[0],
                            msg: messageArr[1]
                        });
                    }
                    console.warn('>> response error happens when send mtop', JSON.stringify(responseError));
                    fail && fail(responseError);
                    complete && complete(responseError);
                }
            });
        }
        catch (err) {
            console.warn('>> exception happens when send mtop', JSON.stringify(err));
            fail && fail(err);
            complete && complete(err);
        }
    };
    return MTop;
}());
exports.MTop = MTop;
exports.default = new MTop();
