import mtop from '../mtop/index.alipay';
import { APIOptions } from '@alife/tg-iot-interface-api-common';

export interface GetDeviceConfigTokenOptions extends APIOptions {
    productKey: string;
    networkType?: string;
    random?: string;
}

class AddDevicePrepare {

    public getDeviceConfigToken(request: GetDeviceConfigTokenOptions): void {
        const finalRequest = Object.assign({}, {
            networkType:'wifi',
            random:'00000000000000000000000000000000',
        }, request);
        const { productKey, networkType, random, success, fail, complete } = finalRequest;

        mtop.sendMtop({
            api: 'mtop.alibaba.aicloud.iot.getTokenForAliPay',
            v: '1.0',
            data: {
                productKey,
                networkType,
                random,
            },
            success,
            fail,
            complete
        });
    }
};

export default new AddDevicePrepare();