import IDevicePanelAPI, { DeviceControlOptions, GetDeviceStatusOptions, GetProductInfoOptions, GetProductTSLOptions, DeleteDeviceOptions, DeviceStatusChangeMessage, MeshDeviceControlOptions } from '@alife/tg-iot-interface-api-device-panel';
export declare class TMPSDK implements IDevicePanelAPI {
    private productInfoCache;
    controlDevice(request: DeviceControlOptions): void;
    controlMeshDevice(request: MeshDeviceControlOptions): void;
    getDeviceConnectStatus(request: GetDeviceStatusOptions): void;
    getDeviceStatus(request: GetDeviceStatusOptions): void;
    getProductInfo(request: GetProductInfoOptions): void;
    getProductTSL(request: GetProductTSLOptions): void;
    deleteDevice(request: DeleteDeviceOptions): void;
    log(msg: any): void;
    /**
     * skill id 缺失时的补偿逻辑
     * @param deviceId 设备id
     * @param skillId 技能id
     * @param success 成功回调
     * @param fail 失败回调
     */
    private _handleSkillId;
    /**
     * 空实现，等子类覆盖
     * @param listener
     */
    onDeviceStatusChange(listener: (mesageArray: Array<DeviceStatusChangeMessage>) => void): void;
    /**
     * 空实现，等子类覆盖
     * @param listener
     */
    offDeviceStatusChange(listener: (mesageArray: Array<DeviceStatusChangeMessage>) => void): void;
}
declare const _default: TMPSDK;
export default _default;
