import IDevicePanelAPI, { DeviceControlOptions, GetDeviceStatusOptions, GetProductInfoOptions, GetProductTSLOptions, DeleteDeviceOptions, DeviceStatusChangeMessage, MeshDeviceControlOptions } from '@alife/tg-iot-interface-api-device-panel';
export declare class TMPSDKTG implements IDevicePanelAPI {
    private serviceId;
    private listenerList;
    constructor();
    controlDevice(request: DeviceControlOptions): void;
    /**
     * 蓝牙 Mesh 设备专属控制接口
     * <p/>
     * 一方接口，仅限内部使用
     * @param request 请求描述
     */
    controlMeshDevice(request: MeshDeviceControlOptions): void;
    getDeviceStatus(request: GetDeviceStatusOptions): void;
    getProductInfo(request: GetProductInfoOptions): void;
    getProductTSL(request: GetProductTSLOptions): void;
    onDeviceStatusChange(listener: (mesageArray: Array<DeviceStatusChangeMessage>) => void): void;
    offDeviceStatusChange(listener: (mesageArray: Array<DeviceStatusChangeMessage>) => void): void;
    deleteDevice(request: DeleteDeviceOptions): void;
    getDeviceConnectStatus(request: GetDeviceStatusOptions): void;
    /**
     * 获取需要的 serviceId
     * @param callback 获得到 serviceId 后的回调
     */
    private getServiceIdAsync;
}
declare const _default: TMPSDKTG;
export default _default;
