import { AplusWindmillAlipay } from '@ali/aplus_universal/plugins/windmill_alipay.js';

/*
埋点SPM列表 https://log.alibaba-inc.com/track/tools/spm 搜索全部

站点A位：a2cmz

## CC端埋点b位 ##
19601026  图兰朵-宜控面板页面	 ***
19601040	图兰朵-宜控面板语料页面	
19601043  图兰朵-宜控面板报错页面	
19601042  图兰朵-宜控面板兜底页面	

## 二郎神端埋点b位 ##
19601107  二郎神-设备列表页面
19601074  二郎神-宜控面板页面	
19601078  二郎神-宜控面板语料页面	
19601086  二郎神-宜控面板报错页面	
19601080  二郎神-宜控面板兜底页面	

## APP端埋点b位 ##
19601103  APP-宜控面板语料页面	
19601100  APP-宜控面板页面
*/ 
const ccList = [{
  index: 0,
  b: '19601026',
  pageName: '图兰朵-宜控面板页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/1'
}, {
  index: 1,
  b: '19601040',
  pageName: '图兰朵-宜控面板语料页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/2'
}, {
  index: 2,
  b: '19601043',
  pageName: '图兰朵-宜控面板报错页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/4'
}, {
  index: 3,
  b: '19601042',
  pageName: '图兰朵-宜控面板兜底页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/3'
}, {
  index: 4,
  b: '20801117',
  pageName: '图兰朵-控制属性次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCControlTimes'
}, {
  index: 5,
  b: '20801148',
  pageName: '图兰朵-控制属性失败次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCControlFailTimes'
}, {
  index: 6,
  b: '20806398',
  pageName: 'CC-进入面板1-10',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCComingPage_1-10'
}, {
  index: 7,
  b: '20806407',
  pageName: 'CC-进入面板11-30',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCComingPage_11-30'
}, {
  index: 8,
  b: '20806413',
  pageName: 'CC-进入面板30-60',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCComingPage_30-60'
}, {
  index: 9,
  b: '20806419',
  pageName: 'CC-进入面板60-180',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCComingPage_60-180'
}, {
  index: 10,
  b: '20806423',
  pageName: 'CC-进入面板>180',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?CCComingPage_>180'
}]

const erlangList = [{
  index: 0,
  b: '19601107',
  pageName: '二郎神-设备列表页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/11'
}, {
  index: 1,
  b: '19601074',
  pageName: '二郎神-宜控面板页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/5'
}, {
  index: 2,
  b: '19601078',
  pageName: '二郎神-宜控面板语料页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/6'
}, {
  index: 3,
  b: '19601086',
  pageName: '二郎神-宜控面板报错页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/8'
}, {
  index: 4,
  b: '19601080',
  pageName: '二郎神-宜控面板兜底页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/7'
}, {
  index: 5,
  b: '20801074',
  pageName: '二郎神-列表快捷控制埋点',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangfastControl'
}, {
  index: 6,
  b: '20801100',
  pageName: '二郎神-控制属性次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangControlTimes'
}, {
  index: 7,
  b: '20801130',
  pageName: '二郎神-控制属性失败次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangControlFailTimes'
}, {
  index: 8,
  b: '20802677',
  pageName: '二郎神-进入面板1-10秒',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangComingPage1-10'
}, {
  index: 9,
  b: '20802729',
  pageName: '二郎神-进入面板11-30秒',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangComingPage11-30'
}, {
  index: 10,
  b: '20802762',
  pageName: '二郎神-进入面板30-60秒',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangComingPage30-60'
}, {
  index: 11,
  b: '20802780',
  pageName: '二郎神-进入面板60-180秒',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangComingPage60-180'
}, {
  index: 12,
  b: '20802790',
  pageName: '二郎神-进入面板>180秒',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangComingPage>180'
}, {
  index: 13,
  b: '20809971',
  pageName: '二郎神快捷控制失败次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?erlangfastControlFail'
}]
// 这边可以搜到，所以你说的这种PK_ 开头的埋点

const appList = [{
  index: 0,
  b: '19601100',
  pageName: 'APP-宜控面板页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/9'
}, {
  index: 1,
  b: '19601103',
  pageName: 'APP-宜控面板语料页面',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com/10'
}, {
  index: 2,
  b: '20801121',
  pageName: 'APP-控制属性次数',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPControlTimes'
}, {
  index: 3,
  b: '20801151',
  pageName: 'APP-控制属性失败次数	',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPControlFailTimes'
}, {
  index: 4,
  b: '20807192',
  pageName: 'APP-进入面板1-10',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPComingPage1-10'
}, {
  index: 5,
  b: '20807197',
  pageName: 'APP-进入面板11-30',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPComingPage11-30'
}, {
  index: 6,
  b: '20807199',
  pageName: 'APP-进入面板30-60',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPComingPage30-60'
}, {
  index: 7,
  b: '20807207',
  pageName: 'APP-进入面板60-180',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPComingPage60-180'
}, {
  index: 8,
  b: '20807211',
  pageName: 'APP-进入面板>180',
  pageUrl: 'https://tmallgenieaiot.alibaba-inc.com?APPComingPage>180'
}]

export default class pageSpm {
  // 列表埋点
  setPageSpmForList() {
    console.log('setPageSpmForList')
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[0])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      // 暂无
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      // 暂无
    }
  }

  // 面板页面埋点
  setPageSpmForPage() {
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[1])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[0])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      this.setPageSPM(appList[0])
    }
  }

  // 语料页面埋点
  setPageSpmForcorpus() {
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[2])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[1])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      this.setPageSPM(appList[1])
    }
  }

  // 兜底页面埋点
  setPageSpmForLastPage() {
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[4])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[3])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      // 暂无
    }
  }

  // 报错页面埋点
  setPageSpmForError() {
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[3])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[2])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      // 暂无
    }
  }

  // 二郎神快捷控制埋点
  setPageSpmErlangFastControl() {
    console.log('setPageSpmErlangFastControl')
    this.setPageSPM(erlangList[5])
  }
  // 二郎神快捷控制埋点
  setPageSpmErlangFastControlFail() {
    console.log('setPageSpmErlangFastControlFail')
    this.setPageSPM(erlangList[13])
  }

  // 控制次数埋点
  setPageSpmControlTimes() {
    console.log('setPageSpmControlTimes')
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[6])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[4])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      this.setPageSPM(appList[2])
    }
  }

  // 控制失败次数埋点
  setPageSpmControlFailTimes() {
    console.log('setPageSpmControlFailTimes')
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      this.setPageSPM(erlangList[7])
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      this.setPageSPM(ccList[5])
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      this.setPageSPM(appList[3])
    }
  }

  // 进入页面时长埋点
  setPageSpmComingPage(time) {
    console.log('埋点this.systemInfo.app', this.systemInfo.app, time)
    if (this.systemInfo.app === 'UNKNOWN' && this.systemInfo.model === 'AliOSThings') { // 二郎神端
      if (time >= 180) {
        this.setPageSPM(erlangList[12])
      } else if(time >= 60){
        this.setPageSPM(erlangList[11])
      } else if(time >= 30){
        this.setPageSPM(erlangList[10])
      } else if(time >= 11){
        this.setPageSPM(erlangList[9])
      } else {
        this.setPageSPM(erlangList[8])
      }
    } else if (this.systemInfo.app === 'genie' || this.systemInfo.app === 'GenieWebApps') { // CC端
      if (time >= 180) {
        this.setPageSPM(ccList[10])
      } else if(time >= 60){
        this.setPageSPM(ccList[9])
      } else if(time >= 30){
        this.setPageSPM(ccList[8])
      } else if(time >= 11){
        this.setPageSPM(ccList[7])
      } else {
        this.setPageSPM(ccList[6])
      }
    } else if (this.systemInfo.app === 'TGenie') { // APP端
      if (time >= 180) {
        this.setPageSPM(appList[8])
      } else if(time >= 60){
        this.setPageSPM(appList[7])
      } else if(time >= 30){
        this.setPageSPM(appList[6])
      } else if(time >= 11){
        this.setPageSPM(appList[5])
      } else {
        this.setPageSPM(appList[4])
      }
    }
  }
  
  // 埋点
  setPageSPM({ a = 'a2cmz', b, pageName, pageUrl }, params = {}) {
    console.log('setPageSPM function start', '***', this.console)
    setTimeout(() => {
      const aplus_universal = AplusWindmillAlipay.create({ method: 'request' });
      aplus_universal.setPageSPM(a, b,()=>{
        console.log(pageName + '-埋点结果*：', b, a)
      });
      aplus_universal.enter({
        'pageName': params.pageName || pageName, // 必选
        'pageUrl': params.pageUrl || pageUrl,   // 必选，页面url（注意：一定要有https前缀）
      }, {
        ...params
      });
    }, 500)
    
    // 黄金令箭
    // aplus_universal.record('/ai_labs_tmall_genie_app.5haojl.jd_for_test','EXP','','GET')
  }
  record(a, b, params, query, eventId) {
    if (query.eventNameId === '2001') {
      this.setPageSPM({
        a: this.spmA,
        b: this.spmB,
        pageName: params.page_name,
        params: {
          eventId,
          ...query
        }
      })
      return
    }

    let ab = '/' + a +'.' + b
    if (params.c) {
      ab += '.' + params.c
    }
    const aplus_universal = AplusWindmillAlipay.create({ method: 'request' });
    aplus_universal.record(params.d || ab, 'CLK', this.splitParams({
      ...query, pageName: params.page_name,
      eventId,
      spm: a + '.' + b
    }), 'GET');
  }
  // 拆分参数
  splitParams(query) {
    let queryString = ''
    for(let i in query) {
      queryString += i + '=' + query[i] + '&'
    }
    return queryString.slice(0, queryString.length - 1)
  }
}