export default class Tools {
  // 获取页面参数
  urlParam () {
    let val
    let href = window.location.href.split('?')[1] || ''
    href = href.split('&')

    const data = {
      urlParamVal: 0
    }
    for (let i = 0; i < href.length; i += 1) {
      val = href[i].split('=')
      if (val[1]) {
        data[val[0]] = decodeURIComponent(val[1])
        data.urlParamVal += 1
      }
    }
    return data
  }

  // 返回上一页面
  goBack() {
    if (getCurrentPages().length <= 1) {
      this.pageDisAppearParams && this.commitHit(this.pageDisAppearParams)
      this.closeMiniProgram()
    } else {
      my.navigateBack()
    }
  }

  // 关闭小程序
  closeMiniProgram() {
    my.call("exitApp", {}, (res) => {})
  }

  // 打开外部页面的链接
  openUrl (url) {
    this.jsBridge('common.pageRouter.openUrl', {
      url
    })
  }

  // 判断手机为Andriod
  isAndriod () {
    return my.getSystemInfoSync().platform === 'Android'
  }

  // 判断手机为IOS
  isIos () {
    return my.getSystemInfoSync().platform === 'iOS'
  }

  // 设置navbar返回事件兼听
  setNavbarBack(callback = '') {
    this.navbarBackListen = ''
    if (callback && typeof callback === 'function') {
      this.navbarBackListen = callback
    }
  }

  // navbar返回
  navbarBack() {
    my.on('SmartSceneBackBtnClickEvent', () => {
      if(this.navbarBackListen) {
        this.navbarBackListen()
      } else {
        this.goBack()
      }
    })
  }

  setBaseSpm(pageName, spm, type, eventName, props = {}) {
    console.error(this.container, '埋点数据：', pageName, spm, type, eventName, JSON.stringify({ ...this.spmParamsData, ...props }))
    if (this.container !== 'erlang') {
      // 页面进入
      this.commitHit({ 
        page_name: pageName, 
        spm: spm, 
        type: type, 
        event_name: eventName,
        props: { ...this.spmParamsData, ...props }
      })
    } else {
      this.record(this.spmA, this.spmB, { page_name: pageName, d: props.eventName }, { 
        ...this.spmParamsData, ...props,
        type: type, event_name: eventName,
      }, eventName)
    }
  }

  // 埋点方法
  commitHit({ page_name, spm, type, event_name, props }) {
    console.error('***' + JSON.stringify({
      type,
      param: {
        event_name: props.spmA + '.' + props.spmB + '.' + event_name,
        spm, //当前页面spm
        page_name, //当前页面名称
        props
      }
    }))
    //页面展示
    my.call('commitHit', {
      type,
      param: {
        event_name: props.spmA + '.' + props.spmB + '.' + event_name,
        spm, //当前页面spm
        page_name, //当前页面名称
        props
      }
    }, (result) => {
        console.log(`埋点返回 ${page_name} ====>`,JSON.stringify(result))
    });
  }

  // 第一个页面，离开页面调用 pageDisAppear 事件
  firstPageOnUnload(params) {
    this.pageDisAppearParams = params
  }

  // 设置
  setNavbar ({
    text = '',
    icon = '',
    title = '',
    callback = () => { }
  }) {
    // 设置用侧
    const event = 'rightItemClick' + Date.parse(new Date());
    const data = {
      event,
      icon,
      text
    }
    // 设置title
    if (title) {
      my.setNavigationBar({
        title
      });
    }
    if (!icon && !text) return

    
    !data.icon && (data.icon = '')
    if (this.isIos() && text) { 
      data.icon = 'text:' + text
    }
    // console.error('navbar参数', data)
    my.call('setRightItem', data, (res) => {})

    my.on(event, callback)
  }

  // 获取2个数值之间的随机数
  random(min, max) {
    if (max == null) {
      max = min;
      min = 0;
    }
    return min + Math.floor(Math.random() * (max - min + 1));
  }

  // 属性值按物模型校验
  checkAttribute(deviceStatus) {
    console.log('this.baseData.deviceInfo***', this.baseData && this.baseData.deviceInfo)
    if (this.baseData.deviceInfo && JSON.stringify(this.baseData.deviceInfo) !== '{}') {
      const attributes = this.baseData.deviceInfo.tsl.attributes
      for (let name in deviceStatus.attr) {
        for (let i = 0; i < attributes.length; i ++) {
          if (attributes[i].attributeEn === name) {
            if (attributes[i].dataType.type === 'boolean' || attributes[i].dataType.type === 'int' || attributes[i].dataType.type === 'enum') {
              deviceStatus.attr[name] = Number(deviceStatus.attr[name])
            }
            break;
          }
        }
      }
    }
  }
}